import { d as defineComponent, aQ as ZFSManager, i as inject, r as ref, c as computed, w as watch, o as onMounted, x as openBlock, Q as createBlock, B as withCtx, A as createVNode, D as unref, aR as CardContainer, Z as createTextVNode, z as createBaseVNode, y as createElementBlock, E as toDisplayString, G as createCommentVNode, C as normalizeClass, ax as withDirectives, aF as vModelSelect, $ as upperCaseWord, O as Fragment, P as renderList, aS as getDiskIDName, ay as vModelCheckbox, F as render, aT as truncateName, aU as Modal, aV as getFullDiskInfo, p as pushNotification, N as Notification, a7 as setRefreservation, l as loadDisksThenPools, a as loadDatasets, b as loadScanObjectGroup, e as loadScanActivities, f as loadDiskStats, h as loadTrimActivities, aW as convertSizeToBytes } from "./index.2c5b72b5.js";
import { l as loadImportablePools } from "./loadImportables.482e66e9.js";
import { r as render$1 } from "./ExclamationTriangleIcon.128ffceb.js";
import { u as ue } from "./switch.b6b8ef92.js";
const _hoisted_1 = ["for"];
const _hoisted_2 = {
  key: 0,
  value: "disk"
};
const _hoisted_3 = {
  key: 1,
  value: "mirror"
};
const _hoisted_4 = {
  key: 2,
  value: "raidz1"
};
const _hoisted_5 = {
  key: 3,
  value: "raidz2"
};
const _hoisted_6 = {
  key: 4,
  value: "raidz3"
};
const _hoisted_7 = { key: 0 };
const _hoisted_8 = ["for"];
const _hoisted_9 = ["for"];
const _hoisted_10 = ["id"];
const _hoisted_11 = ["for"];
const _hoisted_12 = ["id"];
const _hoisted_13 = ["title"];
const _hoisted_14 = ["for"];
const _hoisted_15 = { class: "flex flex-row flex-grow w-full justify-between" };
const _hoisted_16 = ["id", "value", "name"];
const _hoisted_17 = {
  key: 0,
  title: "Disk already has partitions. Proceed with caution.",
  class: "flex items-center justify-center h-6 w-6 bg-default rounded-full ml-2"
};
const _hoisted_18 = {
  key: 1,
  title: "This disk belongs to an exported pool. Force Add to override.",
  class: "flex items-center justify-center h-6 w-6 bg-default rounded-full ml-2"
};
const _hoisted_19 = { class: "truncate text-sm font-medium text-default" };
const _hoisted_20 = { class: "mt-1 truncate text-sm text-default" };
const _hoisted_21 = { class: "mt-1 truncate text-sm text-default" };
const _hoisted_22 = { key: 2 };
const _hoisted_23 = { class: "w-full grid grid-rows-2" };
const _hoisted_24 = { class: "w-full row-start-1 justify-center items-center" };
const _hoisted_25 = { class: "justify-self-start mt-2" };
const _hoisted_26 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_27 = {
  key: 1,
  class: "text-danger"
};
const _hoisted_28 = {
  key: 2,
  class: "text-danger"
};
const _hoisted_29 = {
  key: 3,
  class: "text-danger"
};
const _hoisted_30 = { class: "flex w-full items-center" };
const _hoisted_31 = { class: "button-group-row mt-2" };
const _hoisted_32 = ["id"];
const _hoisted_33 = { class: "flex flex-row items-center justify-center flex-grow text-center" };
const _hoisted_34 = ["for"];
const _hoisted_35 = { class: "button-group-row mt-2" };
const _hoisted_36 = {
  key: 1,
  disabled: "",
  id: "finish",
  type: "button",
  class: "btn btn-primary object-right justify-end h-fit w-full"
};
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "AddVDevModal",
  props: {
    idKey: {},
    pool: {},
    marginTop: {}
  },
  emits: ["close"],
  setup(__props, { emit: __emit }) {
    const zfsManager = new ZFSManager();
    const props = __props;
    const showAddVDevModal = inject("show-vdev-modal");
    const firstVDevType = ref("");
    const firstVDevIsDisk = ref(false);
    function toggleForceAdd() {
      newVDev.value = {
        ...newVDev.value,
        forceAdd: { force: !newVDev.value.forceAdd.force }
      };
    }
    function getVDevType() {
      const firstVDevName = props.pool.vdevs[0].name;
      firstVDevIsDisk.value = props.pool.vdevs[0].disks.length == 1 ? true : false;
      if (!firstVDevIsDisk.value) {
        const strippedType = firstVDevName.substring(0, firstVDevName.indexOf("-"));
        firstVDevType.value = strippedType;
      } else {
        firstVDevType.value = "disk";
      }
      console.log("firstVDevType:", firstVDevType.value);
      newVDev.value.type = firstVDevType.value;
    }
    const newVDev = ref({
      type: firstVDevType.value,
      disks: [],
      isMirror: false,
      forceAdd: { force: false }
    });
    const selectedDisks = ref([]);
    inject("style-truncate-text");
    const diskFeedback = ref("");
    const diskSizeFeedback = ref("");
    const isProperReplicationFeedback = ref("");
    const diskBelongsFeedback = ref("");
    const pools = inject("pools");
    const allDisks = inject("disks");
    const datasets = inject("datasets");
    const diskIdentifier = ref("vdev_path");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    const availableDisks = computed(() => {
      return allDisks.value.filter((disk) => disk.guid === "");
    });
    watch(selectedDisks, (newVal, oldVal) => {
      console.log("selectedDisks:", selectedDisks.value);
    });
    const diskCardClass = (diskName) => {
      const isSelected = selectedDisks.value.includes(diskName);
      return isSelected ? "bg-green-300 dark:bg-green-700" : "";
    };
    const adding = ref(false);
    async function addVDevBtn() {
      if (replicationLevelCheck()) {
        if (diskSizeMatch()) {
          if (diskCheck()) {
            if (!diskBelongsToImportablePool() || newVDev.value.forceAdd) {
              selectedDisks.value.forEach((selectedDisk) => {
                console.log("selectedDisk", selectedDisk);
                const diskNameFinal = getDiskIDName(allDisks.value, diskIdentifier.value, selectedDisk);
                console.log("disk:", diskNameFinal);
                const diskFinal = getFullDiskInfo(allDisks.value, diskNameFinal);
                newVDev.value.disks.push(diskFinal);
                console.log("newVdev.disks:", newVDev.value.disks);
              });
              adding.value = true;
              try {
                const output = await zfsManager.addVDevsToPool(props.pool, [newVDev.value], newVDev.value.forceAdd);
                if (output == null || output.error) {
                  const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
                  pushNotification(new Notification("Add VDev Failed", `There was an error adding this virtual device: ${errorMessage}`, "error", 5e3));
                } else {
                  pushNotification(new Notification("Added VDev", `Virtual device added successfully.`, "success", 5e3));
                  if (props.pool.properties.refreservationRawSize) {
                    const output2 = await setRefreservation(props.pool, props.pool.properties.refreservationPercent);
                    if (output2 == null || output2.error) {
                      const errorMessage = (output2 == null ? void 0 : output2.error) || "Unknown error";
                      pushNotification(new Notification("Refreservation Update Failed", `There was an error updating pools refreservation value: ${errorMessage}`, "error", 5e3));
                    } else {
                      pushNotification(new Notification("Refreservation Updated", `Refreservation of pool was updated successfully.`, "success", 5e3));
                      showAddVDevModal.value = false;
                    }
                  } else {
                    showAddVDevModal.value = false;
                  }
                }
                adding.value = false;
                await refreshAllData();
              } catch (error) {
                pushNotification(new Notification("Add VDev Failed", `There was an error adding this virtual device: ${error}`, "error", 5e3));
                adding.value = false;
                console.error(error);
              }
            }
          }
        }
      }
    }
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      allDisks.value = [];
      pools.value = [];
      datasets.value = [];
      await loadDisksThenPools(allDisks, pools);
      await loadDatasets(datasets);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(pools, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(pools, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
    }
    const replicationLevelCheck = () => {
      let result = true;
      isProperReplicationFeedback.value = "";
      if ((newVDev.value.type == "dedup" || newVDev.value.type == "special") && !newVDev.value.forceAdd && !newVDev.value.isMirror) {
        result = false;
        isProperReplicationFeedback.value = "Mismatched replication level. Forcefully create to override.";
      } else if (newVDev.value.isMirror && (newVDev.value.type == "special" || newVDev.value.type == "dedup" || newVDev.value.type == "log") && selectedDisks.value.length < 2) {
        result = false;
        isProperReplicationFeedback.value = `Two or more Disks are required for Mirror (${upperCaseWord(newVDev.value.type)}).`;
      }
      return result;
    };
    const diskSizeMatch = () => {
      let result = true;
      diskSizeFeedback.value = "";
      if (newVDev.value.forceAdd) {
        return true;
      }
      if (newVDev.value.type === "disk") {
        return true;
      }
      let previousCapacity = 0;
      selectedDisks.value.forEach((selDisk) => {
        const disk = allDisks.value.find((fullDisk) => fullDisk.name == selDisk);
        if (disk) {
          const currentCapacity = convertSizeToBytes(disk.capacity);
          if (previousCapacity != 0 && currentCapacity != previousCapacity) {
            diskSizeFeedback.value = `Mirror contains devices of different sizes. Forcefully create to override.
`;
            result = false;
          }
          previousCapacity = currentCapacity;
        }
      });
      return result;
    };
    const importablePools = inject("importable-pools");
    const diskBelongsToImportablePool = () => {
      let result = false;
      diskBelongsFeedback.value = "";
      if (newVDev.value.forceAdd) {
        return false;
      }
      selectedDisks.value.forEach((diskName) => {
        const selectedDisk = allDisks.value.find((fullDisk) => fullDisk.name == diskName);
        console.log("selectedDisk:", selectedDisk);
        importablePools.value.forEach((pool) => {
          console.log("importablePool:", pool);
          pool.vdevs.forEach((importableVDev) => {
            console.log("importableVDev:", importableVDev);
            importableVDev.disks.forEach((disk) => {
              console.log("importableDisk:", disk);
              if (selectedDisk.name == disk.name) {
                result = true;
                diskBelongsFeedback.value = `This disk was used in exported pool '${pool.name}'.
 Use Force Add to override and use disk in new Vdev.`;
                console.log(`Disk belongs to importable pool: ${pool.name}`);
              }
            });
          });
        });
      });
      console.log("diskBelongsFeedback:", diskBelongsFeedback.value);
      return result;
    };
    const diskCheck = () => {
      let result = true;
      diskFeedback.value = "";
      if (newVDev.value.type == "mirror" && selectedDisks.value.length < 2) {
        diskFeedback.value = "Two or more Disks are required for Mirror.";
        result = false;
      } else if (newVDev.value.type == "raidz1" && selectedDisks.value.length < 3) {
        result = false;
        diskFeedback.value = "Three or more Disks are required for RaidZ1.";
      } else if (newVDev.value.type == "raidz2" && selectedDisks.value.length < 4) {
        result = false;
        diskFeedback.value = "Four or more Disks are required for RaidZ2.";
      } else if (newVDev.value.type == "raidz3" && selectedDisks.value.length < 5) {
        result = false;
        diskFeedback.value = "Five or more Disks are required for RaidZ3.";
      } else if (newVDev.value.type == "disk" && selectedDisks.value.length < 1) {
        diskFeedback.value = "At least one Disk is required.";
        result = false;
      } else if (newVDev.value.type == "log" && selectedDisks.value.length < 1) {
        diskFeedback.value = "At least one Disk is required for Log.";
        result = false;
      } else if (newVDev.value.type == "cache" && selectedDisks.value.length < 1) {
        diskFeedback.value = "At least one Disk is required for Cache.";
        result = false;
      } else if (newVDev.value.type == "special" && selectedDisks.value.length < 1) {
        diskFeedback.value = "At least one Disk is required for Special.";
        result = false;
      } else if (newVDev.value.type == "spare" && selectedDisks.value.length < 1) {
        diskFeedback.value = "At least one Disk is required for Spare.";
        result = false;
      } else if (newVDev.value.type == "dedup" && selectedDisks.value.length < 1) {
        diskFeedback.value = "At least one Disk is required for Dedup.";
        result = false;
      }
      return result;
    };
    const closeModal = () => {
      showAddVDevModal.value = false;
      emit("close");
    };
    const emit = __emit;
    onMounted(() => {
      getVDevType();
      loadImportablePools(importablePools.value);
    });
    const getIdKey = (name) => `${props.idKey}-${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(unref(Modal), {
        onClickOutside: _cache[5] || (_cache[5] = ($event) => closeModal()),
        show: unref(showAddVDevModal),
        class: "!w-3/5 !mt-28 rounded-lg"
      }, {
        default: withCtx(() => [
          createVNode(unref(CardContainer), { class: "!w-3/5 !mt-28 mx-auto rounded-lg" }, {
            header: withCtx(() => _cache[6] || (_cache[6] = [
              createTextVNode(" Add Virtual Device ")
            ])),
            footer: withCtx(() => [
              createBaseVNode("div", _hoisted_23, [
                createBaseVNode("div", _hoisted_24, [
                  createBaseVNode("div", _hoisted_25, [
                    diskFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_26, toDisplayString(diskFeedback.value), 1)) : createCommentVNode("", true),
                    diskSizeFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_27, toDisplayString(diskSizeFeedback.value), 1)) : createCommentVNode("", true),
                    isProperReplicationFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_28, toDisplayString(isProperReplicationFeedback.value), 1)) : createCommentVNode("", true),
                    diskBelongsFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_29, toDisplayString(diskBelongsFeedback.value), 1)) : createCommentVNode("", true)
                  ])
                ]),
                createBaseVNode("div", _hoisted_30, [
                  createBaseVNode("div", _hoisted_31, [
                    createBaseVNode("button", {
                      onClick: _cache[4] || (_cache[4] = ($event) => showAddVDevModal.value = false),
                      id: getIdKey("close-add-vdev-btn"),
                      name: "close-add-vdev-btn",
                      class: "btn btn-danger h-fit"
                    }, " Close ", 8, _hoisted_32)
                  ]),
                  createBaseVNode("div", _hoisted_33, [
                    createBaseVNode("label", {
                      for: getIdKey("force-add-vdev"),
                      class: "mr-2 block text-sm font-medium leading-6 text-default"
                    }, " Forcefully Add ", 8, _hoisted_34),
                    createVNode(unref(ue), {
                      onClick: toggleForceAdd,
                      id: getIdKey("force-add-vdev"),
                      class: normalizeClass([newVDev.value.forceAdd.force ? "bg-primary" : "bg-accent", "relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                    }, {
                      default: withCtx(() => [
                        _cache[18] || (_cache[18] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                        createBaseVNode("span", {
                          class: normalizeClass([newVDev.value.forceAdd.force ? "translate-x-5" : "translate-x-0", " relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                        }, [
                          createBaseVNode("span", {
                            class: normalizeClass([newVDev.value.forceAdd.force ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                            "aria-hidden": "true"
                          }, _cache[16] || (_cache[16] = [
                            createBaseVNode("svg", {
                              class: "h-3 w-3 text-muted",
                              fill: "none",
                              viewBox: "0 0 12 12"
                            }, [
                              createBaseVNode("path", {
                                d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                                stroke: "currentColor",
                                "stroke-width": "2",
                                "stroke-linecap": "round",
                                "stroke-linejoin": "round"
                              })
                            ], -1)
                          ]), 2),
                          createBaseVNode("span", {
                            class: normalizeClass([newVDev.value.forceAdd.force ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                            "aria-hidden": "true"
                          }, _cache[17] || (_cache[17] = [
                            createBaseVNode("svg", {
                              class: "h-3 w-3 text-primary",
                              fill: "currentColor",
                              viewBox: "0 0 12 12"
                            }, [
                              createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                            ], -1)
                          ]), 2)
                        ], 2)
                      ]),
                      _: 1
                    }, 8, ["id", "class"])
                  ]),
                  createBaseVNode("div", _hoisted_35, [
                    !adding.value ? (openBlock(), createElementBlock("button", {
                      key: 0,
                      id: "add-vdev-btn",
                      class: "btn btn-primary object-right justify-end mr-4 h-fit w-full",
                      onClick: addVDevBtn
                    }, "Add VDev")) : createCommentVNode("", true),
                    adding.value ? (openBlock(), createElementBlock("button", _hoisted_36, _cache[19] || (_cache[19] = [
                      createBaseVNode("svg", {
                        "aria-hidden": "true",
                        role: "status",
                        class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                        viewBox: "0 0 100 101",
                        fill: "none",
                        xmlns: "http://www.w3.org/2000/svg"
                      }, [
                        createBaseVNode("path", {
                          d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                          fill: "currentColor"
                        }),
                        createBaseVNode("path", {
                          d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                          fill: "text-success"
                        })
                      ], -1),
                      createTextVNode(" Adding... ")
                    ]))) : createCommentVNode("", true)
                  ])
                ])
              ])
            ]),
            default: withCtx(() => [
              createBaseVNode("div", null, [
                createBaseVNode("div", null, [
                  createBaseVNode("label", {
                    for: getIdKey("virtual-device"),
                    class: "block text-sm font-medium leading-6 text-default"
                  }, "Type", 8, _hoisted_1),
                  withDirectives(createBaseVNode("select", {
                    id: "virtual-device",
                    "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => newVDev.value.type = $event),
                    name: "virtual-device",
                    class: "text-default bg-default mt-1 block w-full input-textlike sm:text-sm sm:leading-6"
                  }, [
                    props.pool.vdevs[0].type == "data" && firstVDevType.value == "disk" ? (openBlock(), createElementBlock("option", _hoisted_2, " Disk ")) : createCommentVNode("", true),
                    props.pool.vdevs[0].type == "data" && firstVDevType.value == "mirror" ? (openBlock(), createElementBlock("option", _hoisted_3, " Mirror")) : createCommentVNode("", true),
                    props.pool.vdevs[0].type == "data" && firstVDevType.value == "raidz1" ? (openBlock(), createElementBlock("option", _hoisted_4, " RaidZ1")) : createCommentVNode("", true),
                    props.pool.vdevs[0].type == "data" && firstVDevType.value == "raidz2" ? (openBlock(), createElementBlock("option", _hoisted_5, " RaidZ2")) : createCommentVNode("", true),
                    props.pool.vdevs[0].type == "data" && firstVDevType.value == "raidz3" ? (openBlock(), createElementBlock("option", _hoisted_6, " RaidZ3")) : createCommentVNode("", true),
                    _cache[7] || (_cache[7] = createBaseVNode("option", { value: "cache" }, "Cache", -1)),
                    _cache[8] || (_cache[8] = createBaseVNode("option", { value: "log" }, "Log", -1)),
                    _cache[9] || (_cache[9] = createBaseVNode("option", { value: "special" }, "Special", -1)),
                    _cache[10] || (_cache[10] = createBaseVNode("option", { value: "spare" }, "Spare", -1)),
                    _cache[11] || (_cache[11] = createBaseVNode("option", { value: "dedup" }, "Dedup", -1))
                  ], 512), [
                    [vModelSelect, newVDev.value.type]
                  ])
                ]),
                newVDev.value.type == "log" || newVDev.value.type == "special" || newVDev.value.type == "dedup" ? (openBlock(), createElementBlock("div", _hoisted_7, [
                  createBaseVNode("label", {
                    for: getIdKey("mirror-enabled"),
                    class: "mt-1 block text-sm font-medium leading-6 text-default"
                  }, toDisplayString(unref(upperCaseWord)(newVDev.value.type)) + " (Mirror)", 9, _hoisted_8),
                  createVNode(unref(ue), {
                    modelValue: newVDev.value.isMirror,
                    "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => newVDev.value.isMirror = $event),
                    class: normalizeClass([newVDev.value.isMirror ? "bg-primary" : "bg-accent", "mt-1  relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[14] || (_cache[14] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([newVDev.value.isMirror ? "translate-x-5" : "translate-x-0", " relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([newVDev.value.isMirror ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[12] || (_cache[12] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([newVDev.value.isMirror ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[13] || (_cache[13] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "class"])
                ])) : createCommentVNode("", true),
                createBaseVNode("div", null, [
                  createBaseVNode("label", {
                    for: getIdKey("disk-identifier"),
                    class: "block text-sm font-medium leading-6 text-default"
                  }, "Disk Identifier", 8, _hoisted_9),
                  withDirectives(createBaseVNode("select", {
                    id: getIdKey("disk-identifier"),
                    "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => diskIdentifier.value = $event),
                    name: "disk-identifier",
                    class: "text-default bg-default mt-1 block w-full input-textlike sm:text-sm sm:leading-6"
                  }, _cache[15] || (_cache[15] = [
                    createBaseVNode("option", { value: "sd_path" }, "Block Device", -1),
                    createBaseVNode("option", { value: "phy_path" }, "Hardware Path", -1),
                    createBaseVNode("option", { value: "vdev_path" }, "Device Alias", -1)
                  ]), 8, _hoisted_10), [
                    [vModelSelect, diskIdentifier.value]
                  ])
                ]),
                createBaseVNode("label", {
                  for: getIdKey("available-disk-list"),
                  class: "my-1 block text-sm font-medium leading-6 text-default"
                }, "Select Disks", 8, _hoisted_11),
                availableDisks.value.length > 0 ? (openBlock(), createElementBlock("ul", {
                  key: 1,
                  id: getIdKey("available-disk-list"),
                  role: "list",
                  class: "flex flex-row flex-wrap gap-2"
                }, [
                  (openBlock(true), createElementBlock(Fragment, null, renderList(availableDisks.value, (disk, diskIdx) => {
                    return openBlock(), createElementBlock("li", {
                      key: diskIdx,
                      class: "my-2"
                    }, [
                      createBaseVNode("button", {
                        class: normalizeClass(["flex min-w-fit w-full h-full border border-default rounded-lg", diskCardClass(disk.name)]),
                        title: disk.hasPartitions ? "Disk already has partitions. Proceed with caution." : unref(getDiskIDName)(unref(allDisks), diskIdentifier.value, disk.name)
                      }, [
                        createBaseVNode("label", {
                          for: getIdKey(`disk-${diskIdx}`),
                          class: "flex flex-col w-full py-4 mx-2 text-sm gap-0.5 justify-start"
                        }, [
                          createBaseVNode("span", _hoisted_15, [
                            withDirectives(createBaseVNode("input", {
                              id: getIdKey(`disk-${diskIdx}`),
                              "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => selectedDisks.value = $event),
                              type: "checkbox",
                              value: `${disk.name}`,
                              name: `disk-${disk.name}`,
                              class: "justify-start w-4 h-4 text-success bg-well border-default rounded focus:ring-green-500 dark:focus:ring-green-600 dark:ring-offset-gray-800 focus:ring-2"
                            }, null, 8, _hoisted_16), [
                              [vModelCheckbox, selectedDisks.value]
                            ]),
                            disk.hasPartitions ? (openBlock(), createElementBlock("div", _hoisted_17, [
                              createVNode(unref(render), { class: "h-6 text-orange-700" })
                            ])) : createCommentVNode("", true),
                            disk.errors && disk.errors.length > 0 ? (openBlock(), createElementBlock("div", _hoisted_18, [
                              createVNode(unref(render$1), { class: "h-6 text-danger" })
                            ])) : createCommentVNode("", true)
                          ]),
                          createBaseVNode("h3", _hoisted_19, toDisplayString(unref(truncateName)(unref(getDiskIDName)(unref(allDisks), diskIdentifier.value, disk.name), 8)), 1),
                          createBaseVNode("p", _hoisted_20, toDisplayString(disk.type), 1),
                          createBaseVNode("p", _hoisted_21, "Capacity: " + toDisplayString(disk.capacity), 1)
                        ], 8, _hoisted_14)
                      ], 10, _hoisted_13)
                    ]);
                  }), 128))
                ], 8, _hoisted_12)) : createCommentVNode("", true),
                availableDisks.value.length == 0 ? (openBlock(), createElementBlock("div", _hoisted_22, " No Disks Available ")) : createCommentVNode("", true)
              ])
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["show"]);
    };
  }
});
const AddVDevModal_vue_vue_type_style_index_0_lang = "";
export {
  _sfc_main as default
};
