import { d as defineComponent, i as inject, r as ref, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, A as createVNode, D as unref, ax as withDirectives, aG as vModelText, aZ as withKeys, Z as createTextVNode, y as createElementBlock, E as toDisplayString, G as createCommentVNode, aH as _sfc_main$1, be as changePassphrase, p as pushNotification, N as Notification } from "./index.2c5b72b5.js";
import { r as render } from "./InformationCircleIcon.cda89ced.js";
const _hoisted_1 = { class: "flex flex-row justify-between items-center" };
const _hoisted_2 = ["for"];
const _hoisted_3 = { title: "Passphrase requires at least 8 characters." };
const _hoisted_4 = ["id"];
const _hoisted_5 = { class: "flex flex-row justify-between items-center" };
const _hoisted_6 = ["for"];
const _hoisted_7 = { title: "Passphrase requires at least 8 characters." };
const _hoisted_8 = ["id"];
const _hoisted_9 = { class: "w-full grid grid-rows-2" };
const _hoisted_10 = { class: "w-full row-start-1" };
const _hoisted_11 = { class: "button-group-row mt-2 justify-self-center" };
const _hoisted_12 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_13 = { class: "button-group-row w-full row-start-2 justify-between mt-2" };
const _hoisted_14 = ["id"];
const _hoisted_15 = ["id"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "ChangePassphrase",
  props: {
    idKey: {},
    filesystem: {}
  },
  setup(__props) {
    const props = __props;
    const showChangePassphrase = inject("show-change-passphrase");
    inject("datasets");
    inject("datasets-loaded");
    const fileSystem = ref(props.filesystem);
    const changing = inject("changing");
    const confirmChange = inject("confirm-change");
    const passphrase = ref("");
    const passphraseConfirm = ref("");
    const passFeedback = ref("");
    async function changeBtn() {
      if (encryptPasswordCheck(fileSystem.value)) {
        changing.value = true;
        try {
          const output = await changePassphrase(fileSystem.value.name, passphrase.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            changing.value = false;
            pushNotification(new Notification("Passphrase Change Failed", `There was an error changing this passphrase: ${errorMessage}`, "error", 5e3));
          } else {
            confirmChange.value = true;
            pushNotification(new Notification("Encryption Passphrase Changed", `Changed passphrase for ${fileSystem.value.name}.`, "success", 5e3));
            changing.value = false;
            showChangePassphrase.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    }
    const encryptPasswordCheck = (fileSystem2) => {
      let result = true;
      passFeedback.value = "";
      if (fileSystem2.encrypted) {
        if (passphraseConfirm.value != passphrase.value) {
          result = false;
          passFeedback.value = "Passphrase does not match.";
        } else if (passphrase.value == "") {
          result = false;
          passFeedback.value = "Passphrase cannot be empty.";
        } else if (passphrase.value.length < 8) {
          result = false;
          passFeedback.value = "Passphrase requires a minimum of 8 characters.";
        }
      }
      return result;
    };
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: unref(showChangePassphrase),
        onClose: _cache[5] || (_cache[5] = ($event) => showChangePassphrase.value = false),
        marginTop: "mt-28",
        width: "w-96",
        minWidth: "min-w-min",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[6] || (_cache[6] = [
          createBaseVNode("legend", { class: "flex justify-center" }, "Change Passphrase", -1)
        ])),
        content: withCtx(() => [
          createBaseVNode("div", null, [
            createBaseVNode("div", null, [
              createBaseVNode("div", _hoisted_1, [
                createBaseVNode("label", {
                  for: getIdKey("passphrase"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default"
                }, "New Passphrase", 8, _hoisted_2),
                createBaseVNode("span", _hoisted_3, [
                  createVNode(unref(render), { class: "ml-2 mt-1 h-6 text-muted" })
                ])
              ]),
              withDirectives(createBaseVNode("input", {
                id: getIdKey("passphrase"),
                type: "password",
                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => passphrase.value = $event),
                name: "passphrase",
                class: "mt-1 block w-full input-textlike bg-default",
                placeholder: "Passphrase"
              }, null, 8, _hoisted_4), [
                [vModelText, passphrase.value]
              ])
            ]),
            createBaseVNode("div", null, [
              createBaseVNode("div", _hoisted_5, [
                createBaseVNode("label", {
                  for: getIdKey("passphrase-confirm"),
                  class: "mt-1 block text-sm font-medium leading-6 text-default"
                }, "Confirm New Passphrase", 8, _hoisted_6),
                createBaseVNode("span", _hoisted_7, [
                  createVNode(unref(render), { class: "ml-2 mt-1 h-6 text-muted" })
                ])
              ]),
              withDirectives(createBaseVNode("input", {
                id: getIdKey("passphrase-confirm"),
                type: "password",
                onKeydown: _cache[1] || (_cache[1] = withKeys(($event) => changeBtn(), ["enter"])),
                "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => passphraseConfirm.value = $event),
                name: "passphrase-confirm",
                class: "mt-1 block w-full input-textlike bg-default",
                placeholder: "Confirm Passphrase"
              }, null, 40, _hoisted_8), [
                [vModelText, passphraseConfirm.value]
              ])
            ]),
            _cache[7] || (_cache[7] = createBaseVNode("div", { class: "my-2 p-2 text-danger text-sm" }, [
              createBaseVNode("p", null, [
                createBaseVNode("strong", null, "Important:"),
                createTextVNode(" Please note your passphrase carefully. If it is lost, it cannot be retrieved or reset.")
              ])
            ], -1))
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_9, [
            createBaseVNode("div", _hoisted_10, [
              createBaseVNode("div", _hoisted_11, [
                passFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_12, toDisplayString(passFeedback.value), 1)) : createCommentVNode("", true)
              ])
            ]),
            createBaseVNode("div", _hoisted_13, [
              createBaseVNode("button", {
                id: "cancel",
                class: "mt-1 btn btn-danger object-left justify-start h-fit",
                onClick: _cache[3] || (_cache[3] = ($event) => showChangePassphrase.value = false)
              }, "Cancel"),
              !unref(changing) ? (openBlock(), createElementBlock("button", {
                key: 0,
                onClick: _cache[4] || (_cache[4] = ($event) => changeBtn()),
                id: getIdKey("change-passphrase-btn"),
                name: "change-passphrase-btn",
                class: "mt-1 btn btn-primary object-right justify-end h-fit"
              }, "Change", 8, _hoisted_14)) : createCommentVNode("", true),
              unref(changing) ? (openBlock(), createElementBlock("button", {
                key: 1,
                disabled: "",
                id: getIdKey("change-pass-spinner"),
                type: "button",
                class: "btn btn-danger object-right justify-end"
              }, _cache[8] || (_cache[8] = [
                createBaseVNode("svg", {
                  "aria-hidden": "true",
                  role: "status",
                  class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                  viewBox: "0 0 100 101",
                  fill: "none",
                  xmlns: "http://www.w3.org/2000/svg"
                }, [
                  createBaseVNode("path", {
                    d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                    fill: "currentColor"
                  }),
                  createBaseVNode("path", {
                    d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                    fill: "text-success"
                  })
                ], -1),
                createTextVNode(" Changing... ")
              ]), 8, _hoisted_15)) : createCommentVNode("", true)
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
