import { d as defineComponent, r as ref, i as inject, c as computed, w as watch, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, y as createElementBlock, D as unref, O as Fragment, P as renderList, C as normalizeClass, ax as withDirectives, b0 as vModelRadio, E as toDisplayString, A as createVNode, F as render, G as createCommentVNode, aF as vModelSelect, aG as vModelText, Z as createTextVNode, aH as _sfc_main$2, b1 as importPool, p as pushNotification, N as Notification, l as loadDisksThenPools, a as loadDatasets, b as loadScanObjectGroup, e as loadScanActivities, f as loadDiskStats, h as loadTrimActivities } from "./index.2c5b72b5.js";
import { _ as _sfc_main$1 } from "./LoadingSpinner.vue_vue_type_script_setup_true_lang.38ea0b01.js";
import { l as loadImportablePools, a as loadImportableDestroyedPools } from "./loadImportables.482e66e9.js";
import { u as ue } from "./switch.b6b8ef92.js";
const _hoisted_1 = { class: "grid grid-cols-3" };
const _hoisted_2 = { class: "mt-2 col-span-3" };
const _hoisted_3 = ["for"];
const _hoisted_4 = ["id"];
const _hoisted_5 = { key: 0 };
const _hoisted_6 = { key: 0 };
const _hoisted_7 = ["for"];
const _hoisted_8 = ["onChange", "id", "value", "name"];
const _hoisted_9 = {
  key: 0,
  title: "Pool has errors. Must Forcefully Import"
};
const _hoisted_10 = {
  key: 1,
  class: "relative flex justify-center items-stretch"
};
const _hoisted_11 = { key: 1 };
const _hoisted_12 = ["for"];
const _hoisted_13 = ["onChange", "id", "value", "name"];
const _hoisted_14 = {
  key: 0,
  title: "Pool has errors. Must Forcefully Import"
};
const _hoisted_15 = {
  key: 1,
  class: "relative flex"
};
const _hoisted_16 = { key: 1 };
const _hoisted_17 = { class: "mt-2 col-span-1" };
const _hoisted_18 = ["for"];
const _hoisted_19 = { class: "mt-2 col-span-2" };
const _hoisted_20 = ["for"];
const _hoisted_21 = ["id"];
const _hoisted_22 = { class: "mt-2 col-span-1" };
const _hoisted_23 = ["for"];
const _hoisted_24 = {
  key: 0,
  class: "mt-2 col-span-2"
};
const _hoisted_25 = ["for"];
const _hoisted_26 = ["id"];
const _hoisted_27 = { class: "mt-2 col-span-3" };
const _hoisted_28 = ["for"];
const _hoisted_29 = ["id"];
const _hoisted_30 = { class: "mt-2 col-span-1" };
const _hoisted_31 = ["for"];
const _hoisted_32 = { class: "mt-2 col-span-1" };
const _hoisted_33 = ["for"];
const _hoisted_34 = { class: "mt-2 col-span-1" };
const _hoisted_35 = ["for"];
const _hoisted_36 = { class: "mt-2 col-span-1" };
const _hoisted_37 = ["for"];
const _hoisted_38 = { class: "mt-2 col-span-1" };
const _hoisted_39 = ["for"];
const _hoisted_40 = { class: "w-full grid grid-rows-2" };
const _hoisted_41 = { class: "w-full row-start-1" };
const _hoisted_42 = { class: "mt-2" };
const _hoisted_43 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_44 = { class: "button-group-row w-full row-start-2 justify-between mt-2" };
const _hoisted_45 = ["id"];
const _hoisted_46 = ["id"];
const _hoisted_47 = ["id"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "ImportPool",
  setup(__props) {
    const showDeletedPools = ref(false);
    const showImportModal = inject("show-import-modal");
    const disks = inject("disks");
    const pools = inject("pools");
    const datasets = inject("datasets");
    const importablePools = inject("importable-pools");
    const allImportableDestroyedPools = inject("importable-destroyed-pools");
    const importableDestroyedPools = computed(() => {
      return allImportableDestroyedPools.value.filter((destroyedPool) => {
        return !importablePools.value.some((importablePool) => destroyedPool.guid === importablePool.guid);
      });
    });
    const importing = ref(false);
    const loading = ref(true);
    const nameFeedback = ref("");
    const disksLoaded = inject("disks-loaded");
    const poolsLoaded = inject("pools-loaded");
    const fileSystemsLoaded = inject("datasets-loaded");
    const scanObjectGroup = inject("scan-object-group");
    const poolDiskStats = inject("pool-disk-stats");
    const scanActivities = inject("scan-activities");
    const trimActivities = inject("trim-activities");
    const poolSelectedClass = (poolGUID) => {
      return poolGUID === importedPool.value.poolGUID ? "bg-green-300 dark:bg-green-700" : "";
    };
    function loadImports() {
      loading.value = true;
      importablePools.value = [];
      loadImportablePools(importablePools.value);
      loading.value = false;
    }
    function loadDestroyedImports() {
      loading.value = true;
      allImportableDestroyedPools.value = [];
      loadImportableDestroyedPools(allImportableDestroyedPools.value);
      loading.value = false;
    }
    loadImports();
    watch(showDeletedPools, async (newValue, oldValue) => {
      if (showDeletedPools) {
        loadDestroyedImports();
      } else {
        loadImports();
      }
    });
    const importedPool = ref({
      name: "",
      poolGUID: "",
      altRoot: "",
      renamePool: false,
      newPoolName: "",
      identifier: "vdev_path",
      forceImport: false,
      recoveryMode: false,
      ignoreMissingLog: false,
      mountFileSystems: true,
      readOnly: false,
      isDestroyed: false,
      errors: []
    });
    function isPoolDestroyed() {
      return importableDestroyedPools.value.some((pool) => pool.guid === importedPool.value.poolGUID);
    }
    function updateImportedPoolData(pool) {
      importedPool.value.name = pool.name;
      importedPool.value.errors = pool.errors;
    }
    const nameCheck = () => {
      let result = true;
      nameFeedback.value = "";
      console.log("importedPool.newName:", importedPool.value.newPoolName);
      if (importedPool.value.renamePool) {
        if (importedPool.value.newPoolName == "") {
          result = false;
          nameFeedback.value = "Name cannot be empty.";
        } else if (importedPool.value.newPoolName.match(/^[0-9]/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with numbers.";
        } else if (importedPool.value.newPoolName.match(/^[.]/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with a period (.).";
        } else if (importedPool.value.newPoolName.match(/^[_]/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with an underscore (_).";
        } else if (importedPool.value.newPoolName.match(/^[-]/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with a hyphen (-).";
        } else if (importedPool.value.newPoolName.match(/^[:]/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with a colon (:).";
        } else if (importedPool.value.newPoolName.match(/^[ ]/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with whitespace.";
        } else if (importedPool.value.newPoolName.match(/[ ]$/)) {
          result = false;
          nameFeedback.value = "Name cannot end with whitespace.";
        } else if (importedPool.value.newPoolName.match(/^c[0-9]|^log|^mirror|^raidz|^raidz1|^raidz2|^raidz3|^spare/)) {
          result = false;
          nameFeedback.value = "Name cannot begin with a reserved name.";
        } else if (!importedPool.value.newPoolName.match(/^[a-zA-Z0-9_.:-]*$/)) {
          result = false;
          nameFeedback.value = "Name contains invalid characters.";
        } else if (importableNameExists()) {
          result = false;
          nameFeedback.value = "A pool with that name already exists.";
        }
      }
      return result;
    };
    function importableNameExists() {
      return importablePools.value.some((pool) => {
        return importedPool.value.newPoolName === pool.name;
      });
    }
    async function refreshAllData() {
      disksLoaded.value = false;
      poolsLoaded.value = false;
      fileSystemsLoaded.value = false;
      disks.value = [];
      pools.value = [];
      datasets.value = [];
      await loadDisksThenPools(disks, pools);
      await loadDatasets(datasets);
      await loadScanObjectGroup(scanObjectGroup);
      await loadScanActivities(pools, scanActivities);
      await loadDiskStats(poolDiskStats);
      await loadTrimActivities(pools, trimActivities);
      disksLoaded.value = true;
      poolsLoaded.value = true;
      fileSystemsLoaded.value = true;
    }
    async function importPoolBtn() {
      if (nameCheck()) {
        if (isPoolDestroyed()) {
          importedPool.value.isDestroyed = true;
        }
        console.log("importing pool:", importedPool.value);
        try {
          importing.value = true;
          const output = await importPool(importedPool.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            pushNotification(new Notification("Import Failed", `Failed to Import Pool: ${errorMessage}`, "error", 5e3));
          } else {
            pushNotification(new Notification("Import Completed", `Imported Pool ${importedPool.value.name} from Pool ${importedPool.value.name}`, "success", 5e3));
            showImportModal.value = false;
          }
          importing.value = false;
          await refreshAllData();
        } catch (error) {
          pushNotification(new Notification("Import Failed", `Failed to Import Pool: ${error}.`, "error", 5e3));
          importing.value = false;
        }
      }
    }
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$2, {
        isOpen: unref(showImportModal),
        onClose: _cache[14] || (_cache[14] = ($event) => showImportModal.value = false),
        marginTop: "mt-28",
        width: "w-3/5",
        minWidth: "min-w-3/5",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => _cache[15] || (_cache[15] = [
          createBaseVNode("legend", { class: "flex justify-center" }, "Import Pool", -1)
        ])),
        content: withCtx(() => [
          createBaseVNode("div", null, [
            createBaseVNode("div", _hoisted_1, [
              createBaseVNode("div", _hoisted_2, [
                createBaseVNode("label", {
                  for: getIdKey("available-pool-list"),
                  class: "my-1 block text-sm font-medium leading-6 text-default"
                }, "Select Pool", 8, _hoisted_3),
                createBaseVNode("ul", {
                  id: getIdKey("available-pool-list"),
                  role: "list",
                  class: "grid gap-1 grid-cols-1 p-1 border border-default rounded-md bg-accent overflow-y-auto h-56 min-h-min"
                }, [
                  !loading.value ? (openBlock(), createElementBlock("div", _hoisted_5, [
                    !showDeletedPools.value ? (openBlock(), createElementBlock("div", _hoisted_6, [
                      unref(importablePools).length > 0 ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(unref(importablePools), (pool, idx) => {
                        return openBlock(), createElementBlock("li", {
                          key: idx,
                          class: "col-span-1"
                        }, [
                          createBaseVNode("button", {
                            class: normalizeClass(["flex min-w-fit w-full h-fit min-h-fit border border-default bg-well rounded-md", poolSelectedClass(pool.guid)])
                          }, [
                            createBaseVNode("label", {
                              for: getIdKey(`pool-${idx}`),
                              class: "flex flex-col w-full py-2 mb-1 mx-2 text-default"
                            }, [
                              withDirectives(createBaseVNode("input", {
                                "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => importedPool.value.poolGUID = $event),
                                onChange: ($event) => updateImportedPoolData(pool),
                                id: getIdKey(`pool-${idx}`),
                                type: "radio",
                                value: `${pool.guid}`,
                                name: `pool-${pool.name}-${pool.guid}`,
                                class: "w-4 h-4 text-success bg-well border-default rounded focus:ring-green-500 dark:focus:ring-green-600 dark:ring-offset-gray-800 focus:ring-1"
                              }, null, 40, _hoisted_8), [
                                [vModelRadio, importedPool.value.poolGUID]
                              ]),
                              createBaseVNode("p", null, "Name: " + toDisplayString(pool.name), 1),
                              createBaseVNode("p", null, "GUID: " + toDisplayString(pool.guid), 1),
                              createBaseVNode("p", null, "Status: " + toDisplayString(pool.status), 1),
                              createBaseVNode("p", null, "Destroyed: " + toDisplayString(pool.isDestroyed), 1),
                              pool.errors.length > 0 ? (openBlock(), createElementBlock("span", _hoisted_9, [
                                createVNode(unref(render), { class: "text-danger h-6" })
                              ])) : createCommentVNode("", true)
                            ], 8, _hoisted_7)
                          ], 2)
                        ]);
                      }), 128)) : (openBlock(), createElementBlock("div", _hoisted_10, _cache[16] || (_cache[16] = [
                        createBaseVNode("p", { class: "absolute inset-0 grow text-center text-xl font-medium text-default p-10" }, " No Importable Pools Found", -1)
                      ])))
                    ])) : createCommentVNode("", true),
                    showDeletedPools.value ? (openBlock(), createElementBlock("div", _hoisted_11, [
                      importableDestroyedPools.value.length > 0 ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(importableDestroyedPools.value, (pool, idx) => {
                        return openBlock(), createElementBlock("li", {
                          key: idx,
                          class: "col-span-1"
                        }, [
                          createBaseVNode("button", {
                            class: normalizeClass(["flex min-w-fit w-full h-fit min-h-fit border border-default bg-well rounded-md", poolSelectedClass(pool.guid)])
                          }, [
                            createBaseVNode("label", {
                              for: getIdKey(`pool-${idx}`),
                              class: "flex flex-col w-full py-2 mb-1 mx-2 text-default"
                            }, [
                              withDirectives(createBaseVNode("input", {
                                "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => importedPool.value.poolGUID = $event),
                                onChange: ($event) => updateImportedPoolData(pool),
                                id: getIdKey(`pool-${idx}`),
                                type: "radio",
                                value: `${pool.guid}`,
                                name: `pool-${pool.name}-${pool.guid}`,
                                class: "w-4 h-4 text-success bg-well border-default rounded focus:ring-green-500 dark:focus:ring-green-600 dark:ring-offset-gray-800 focus:ring-1"
                              }, null, 40, _hoisted_13), [
                                [vModelRadio, importedPool.value.poolGUID]
                              ]),
                              createBaseVNode("p", null, "Name: " + toDisplayString(pool.name), 1),
                              createBaseVNode("p", null, "GUID: " + toDisplayString(pool.guid), 1),
                              createBaseVNode("p", null, "Status: " + toDisplayString(pool.status), 1),
                              createBaseVNode("p", null, "Destroyed: " + toDisplayString(pool.isDestroyed), 1),
                              pool.errors.length > 0 ? (openBlock(), createElementBlock("span", _hoisted_14, [
                                createVNode(unref(render), { class: "text-danger h-6" })
                              ])) : createCommentVNode("", true)
                            ], 8, _hoisted_12)
                          ], 2)
                        ]);
                      }), 128)) : (openBlock(), createElementBlock("div", _hoisted_15, _cache[17] || (_cache[17] = [
                        createBaseVNode("p", { class: "absolute inset-0 grow text-center text-xl font-medium text-default p-10" }, " No Destroyed Pools Found", -1)
                      ])))
                    ])) : createCommentVNode("", true)
                  ])) : (openBlock(), createElementBlock("div", _hoisted_16, [
                    createVNode(_sfc_main$1, {
                      width: "w-10",
                      height: "h-10",
                      baseColor: "text-gray-200",
                      fillColor: "fill-slate-500",
                      class: "font-semibold text-lg my-0.5"
                    })
                  ]))
                ], 8, _hoisted_4)
              ]),
              createBaseVNode("div", _hoisted_17, [
                createBaseVNode("label", {
                  for: getIdKey("show-destroyed-pools-switch"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Show Destroyed Pools", 8, _hoisted_18),
                createVNode(unref(ue), {
                  modelValue: showDeletedPools.value,
                  "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => showDeletedPools.value = $event),
                  id: getIdKey("show-destroyed-pools-switch"),
                  class: normalizeClass([showDeletedPools.value ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[20] || (_cache[20] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([showDeletedPools.value ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([showDeletedPools.value ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[18] || (_cache[18] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([showDeletedPools.value ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[19] || (_cache[19] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ]),
              createBaseVNode("div", _hoisted_19, [
                createBaseVNode("label", {
                  for: getIdKey("disk-identifier"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Disk Identifier", 8, _hoisted_20),
                withDirectives(createBaseVNode("select", {
                  id: getIdKey("disk-identifier"),
                  "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => importedPool.value.identifier = $event),
                  name: "",
                  class: "mt-1 block w-full input-textlike bg-default"
                }, _cache[21] || (_cache[21] = [
                  createBaseVNode("option", { value: "vdev_path" }, "Device Alias", -1),
                  createBaseVNode("option", { value: "sd_path" }, "Block Device", -1),
                  createBaseVNode("option", { value: "phy_path" }, "Hardware Path", -1)
                ]), 8, _hoisted_21), [
                  [vModelSelect, importedPool.value.identifier]
                ])
              ]),
              createBaseVNode("div", _hoisted_22, [
                createBaseVNode("label", {
                  for: getIdKey("rename-pool-switch"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Rename Pool", 8, _hoisted_23),
                createVNode(unref(ue), {
                  modelValue: importedPool.value.renamePool,
                  "onUpdate:modelValue": _cache[4] || (_cache[4] = ($event) => importedPool.value.renamePool = $event),
                  id: getIdKey("rename-pool-switch"),
                  class: normalizeClass([importedPool.value.renamePool ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[24] || (_cache[24] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([importedPool.value.renamePool ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.renamePool ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[22] || (_cache[22] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.renamePool ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[23] || (_cache[23] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ]),
              importedPool.value.renamePool ? (openBlock(), createElementBlock("div", _hoisted_24, [
                createBaseVNode("label", {
                  for: getIdKey("new-pool-name"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "New Name", 8, _hoisted_25),
                withDirectives(createBaseVNode("input", {
                  type: "text",
                  "onUpdate:modelValue": _cache[5] || (_cache[5] = ($event) => importedPool.value.newPoolName = $event),
                  name: "pool-name",
                  id: getIdKey("new-pool-name"),
                  class: "mt-1 block w-full input-textlike bg-default",
                  placeholder: "New Pool Name"
                }, null, 8, _hoisted_26), [
                  [vModelText, importedPool.value.newPoolName]
                ])
              ])) : createCommentVNode("", true),
              createBaseVNode("div", _hoisted_27, [
                createBaseVNode("label", {
                  for: getIdKey("alt-root"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Alt Root", 8, _hoisted_28),
                withDirectives(createBaseVNode("input", {
                  type: "text",
                  "onUpdate:modelValue": _cache[6] || (_cache[6] = ($event) => importedPool.value.altRoot = $event),
                  name: "pool-name",
                  id: getIdKey("alt-root"),
                  class: "mt-1 block w-full input-textlike bg-default",
                  placeholder: "Alt Root"
                }, null, 8, _hoisted_29), [
                  [vModelText, importedPool.value.altRoot]
                ])
              ]),
              createBaseVNode("div", _hoisted_30, [
                createBaseVNode("label", {
                  for: getIdKey("read-only"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Read Only", 8, _hoisted_31),
                createVNode(unref(ue), {
                  modelValue: importedPool.value.readOnly,
                  "onUpdate:modelValue": _cache[7] || (_cache[7] = ($event) => importedPool.value.readOnly = $event),
                  id: getIdKey("read-only"),
                  class: normalizeClass([importedPool.value.readOnly ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[27] || (_cache[27] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([importedPool.value.readOnly ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.readOnly ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[25] || (_cache[25] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.readOnly ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[26] || (_cache[26] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ]),
              createBaseVNode("div", _hoisted_32, [
                createBaseVNode("label", {
                  for: getIdKey("recovery-mode"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Recovery Mode", 8, _hoisted_33),
                createVNode(unref(ue), {
                  modelValue: importedPool.value.recoveryMode,
                  "onUpdate:modelValue": _cache[8] || (_cache[8] = ($event) => importedPool.value.recoveryMode = $event),
                  id: getIdKey("recovery-mode"),
                  class: normalizeClass([importedPool.value.recoveryMode ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[30] || (_cache[30] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([importedPool.value.recoveryMode ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.recoveryMode ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[28] || (_cache[28] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.recoveryMode ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[29] || (_cache[29] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ]),
              createBaseVNode("div", _hoisted_34, [
                createBaseVNode("label", {
                  for: getIdKey("ignore-missing-logs"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Ignore Missing Log Devices", 8, _hoisted_35),
                createVNode(unref(ue), {
                  modelValue: importedPool.value.ignoreMissingLog,
                  "onUpdate:modelValue": _cache[9] || (_cache[9] = ($event) => importedPool.value.ignoreMissingLog = $event),
                  id: getIdKey("ignore-missing-logs"),
                  class: normalizeClass([importedPool.value.ignoreMissingLog ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[33] || (_cache[33] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([importedPool.value.ignoreMissingLog ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.ignoreMissingLog ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[31] || (_cache[31] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.ignoreMissingLog ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[32] || (_cache[32] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ]),
              createBaseVNode("div", _hoisted_36, [
                createBaseVNode("label", {
                  for: getIdKey("mount-filesystems"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Mount File Systems", 8, _hoisted_37),
                createVNode(unref(ue), {
                  modelValue: importedPool.value.mountFileSystems,
                  "onUpdate:modelValue": _cache[10] || (_cache[10] = ($event) => importedPool.value.mountFileSystems = $event),
                  id: getIdKey("mount-filesystems"),
                  class: normalizeClass([importedPool.value.mountFileSystems ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[36] || (_cache[36] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([importedPool.value.mountFileSystems ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.mountFileSystems ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[34] || (_cache[34] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.mountFileSystems ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[35] || (_cache[35] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ]),
              createBaseVNode("div", _hoisted_38, [
                createBaseVNode("label", {
                  for: getIdKey("force-import"),
                  class: "mt-1 bg-default block text-sm leading-6 text-default"
                }, "Forcefully Import", 8, _hoisted_39),
                createVNode(unref(ue), {
                  modelValue: importedPool.value.forceImport,
                  "onUpdate:modelValue": _cache[11] || (_cache[11] = ($event) => importedPool.value.forceImport = $event),
                  id: getIdKey("force-import"),
                  class: normalizeClass([importedPool.value.forceImport ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                }, {
                  default: withCtx(() => [
                    _cache[39] || (_cache[39] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                    createBaseVNode("span", {
                      class: normalizeClass([importedPool.value.forceImport ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                    }, [
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.forceImport ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[37] || (_cache[37] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-muted",
                          fill: "none",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", {
                            d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                            stroke: "currentColor",
                            "stroke-width": "2",
                            "stroke-linecap": "round",
                            "stroke-linejoin": "round"
                          })
                        ], -1)
                      ]), 2),
                      createBaseVNode("span", {
                        class: normalizeClass([importedPool.value.forceImport ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                        "aria-hidden": "true"
                      }, _cache[38] || (_cache[38] = [
                        createBaseVNode("svg", {
                          class: "h-3 w-3 text-primary",
                          fill: "currentColor",
                          viewBox: "0 0 12 12"
                        }, [
                          createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                        ], -1)
                      ]), 2)
                    ], 2)
                  ]),
                  _: 1
                }, 8, ["modelValue", "id", "class"])
              ])
            ])
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_40, [
            createBaseVNode("div", _hoisted_41, [
              createBaseVNode("div", _hoisted_42, [
                nameFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_43, toDisplayString(nameFeedback.value), 1)) : createCommentVNode("", true)
              ])
            ]),
            createBaseVNode("div", _hoisted_44, [
              createBaseVNode("button", {
                onClick: _cache[12] || (_cache[12] = ($event) => showImportModal.value = false),
                id: getIdKey("cancel-import"),
                name: "cancel-import",
                class: "mt-1 btn btn-danger object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_45),
              !importing.value ? (openBlock(), createElementBlock("button", {
                key: 0,
                onClick: _cache[13] || (_cache[13] = ($event) => importPoolBtn()),
                id: getIdKey("import-pool-btn"),
                name: "import-pool-btn",
                class: "mt-1 btn btn-primary object-right justify-end h-fit"
              }, "Import", 8, _hoisted_46)) : createCommentVNode("", true),
              importing.value ? (openBlock(), createElementBlock("button", {
                key: 1,
                disabled: "",
                id: getIdKey("import-pool-spinner"),
                type: "button",
                class: "btn btn-danger object-right justify-end"
              }, _cache[40] || (_cache[40] = [
                createBaseVNode("svg", {
                  "aria-hidden": "true",
                  role: "status",
                  class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                  viewBox: "0 0 100 101",
                  fill: "none",
                  xmlns: "http://www.w3.org/2000/svg"
                }, [
                  createBaseVNode("path", {
                    d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                    fill: "currentColor"
                  }),
                  createBaseVNode("path", {
                    d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                    fill: "text-success"
                  })
                ], -1),
                createTextVNode(" Importing... ")
              ]), 8, _hoisted_47)) : createCommentVNode("", true)
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
