import { d as defineComponent, i as inject, r as ref, x as openBlock, Q as createBlock, B as withCtx, z as createBaseVNode, E as toDisplayString, D as unref, $ as upperCaseWord, y as createElementBlock, C as normalizeClass, Z as createTextVNode, ax as withDirectives, aZ as withKeys, aG as vModelText, G as createCommentVNode, A as createVNode, aH as _sfc_main$1, am as lockFileSystem, p as pushNotification, N as Notification, bf as isPassphraseValid, bg as unlockFileSystem, an as mountFileSystem } from "./index.2c5b72b5.js";
import { r as render, a as render$1 } from "./EyeIcon.6621bebe.js";
import { u as ue } from "./switch.b6b8ef92.js";
const _hoisted_1 = { class: "flex justify-center" };
const _hoisted_2 = { class: "grid grid-flow-row mt-3 text-center" };
const _hoisted_3 = {
  key: 0,
  class: "w-full grid grid-cols-3"
};
const _hoisted_4 = { class: "col-span-3 flex flex-row" };
const _hoisted_5 = ["for", "title"];
const _hoisted_6 = ["title"];
const _hoisted_7 = { class: "col-span-3 justify-between text-center items-center grid grid-cols-3" };
const _hoisted_8 = { class: "col-span-2 flex flex-row gap-1 text-center items-center" };
const _hoisted_9 = ["for"];
const _hoisted_10 = ["id"];
const _hoisted_11 = ["id"];
const _hoisted_12 = { class: "col-span-1 button-group-row justify-end" };
const _hoisted_13 = { class: "col-span-3 flex flex-row" };
const _hoisted_14 = { class: "text-danger mt-1" };
const _hoisted_15 = { class: "grid grid-rows-2 col-span-3" };
const _hoisted_16 = { class: "flex flex-row justify-between" };
const _hoisted_17 = ["for"];
const _hoisted_18 = { class: "flex flex-row justify-between" };
const _hoisted_19 = ["for"];
const _hoisted_20 = {
  key: 1,
  class: "w-full grid grid-cols-2"
};
const _hoisted_21 = { class: "col-span-2" };
const _hoisted_22 = ["title"];
const _hoisted_23 = { class: "w-full grid grid-rows-1" };
const _hoisted_24 = { class: "button-group-row mt-2 justify-between" };
const _hoisted_25 = ["id"];
const _hoisted_26 = ["id"];
const _hoisted_27 = ["id"];
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "LockUnlockFileSystem",
  props: {
    idKey: {},
    mode: {},
    filesystem: {},
    showFlag: { type: Boolean }
  },
  emits: ["close"],
  setup(__props, { emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const truncateText = inject("style-truncate-text");
    const showFlag = ref(props.showFlag);
    const showPassword = ref(false);
    const doingThing = inject("locking-or-unlocking");
    const showLockUnlockModal = inject("show-lock-unlock-modal");
    const confirmLockOrUnlock = inject("confirm-lock-or-unlock");
    const updateShowFlag = () => {
      if (props.showFlag !== showFlag.value) {
        showFlag.value = props.showFlag;
      }
    };
    const closeModal = () => {
      emit("close");
    };
    const passphrase = ref("");
    const passFeedback = ref("");
    const passValid = ref(false);
    const mountFS = ref(true);
    const forceMountFS = ref(false);
    async function confirmBtn() {
      if (props.mode == "lock") {
        doingThing.value = true;
        try {
          const lockOutput = await lockFileSystem(props.filesystem);
          if (lockOutput == null || lockOutput.error) {
            const errorMessage = (lockOutput == null ? void 0 : lockOutput.error) || "Unknown error";
            doingThing.value = false;
            pushNotification(new Notification("Lock Dataset Failed", `Failed to lock ${props.filesystem.name}: ${errorMessage}`, "error", 5e3));
          } else {
            pushNotification(new Notification("Dataset Locked", `Successfully locked ${props.filesystem.name}.`, "success", 5e3));
            doingThing.value = false;
            confirmLockOrUnlock.value = true;
            showLockUnlockModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      } else if (props.mode == "unlock") {
        passValid.value = await isPassphraseValid(props.filesystem.name, passphrase.value);
        if (passValid.value) {
          doingThing.value = true;
          try {
            const unlockOutput = await unlockFileSystem(props.filesystem, passphrase.value);
            if (unlockOutput == null || unlockOutput.error) {
              const errorMessage = (unlockOutput == null ? void 0 : unlockOutput.error) || "Unknown error";
              doingThing.value = false;
              pushNotification(new Notification("Unlock Dataset Failed", `Failed to unlock ${props.filesystem.name}: ${errorMessage}`, "error", 5e3));
            } else {
              if (mountFS.value) {
                try {
                  const mountOutput = await mountFileSystem(props.filesystem, forceMountFS.value);
                  if (mountOutput == null || mountOutput.error) {
                    const errorMessage = (mountOutput == null ? void 0 : mountOutput.error) || "Unknown error";
                    pushNotification(new Notification("Mount Dataset Failed", `${props.filesystem.name} was not mounted: ${errorMessage}`, "error", 5e3));
                  } else {
                    pushNotification(new Notification("File System Mounted", props.filesystem.name + " mounted.", "success", 5e3));
                  }
                } catch (error) {
                  console.error(error);
                }
              }
              pushNotification(new Notification("Dataset Unlocked", `Successfully unlocked ${props.filesystem.name}.`, "success", 5e3));
              doingThing.value = false;
              confirmLockOrUnlock.value = true;
              showLockUnlockModal.value = false;
            }
          } catch (error) {
            console.error(error);
          }
        } else {
          passFeedback.value = "Passphrase is invalid.";
        }
      }
    }
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$1, {
        isOpen: showFlag.value,
        onClose: updateShowFlag,
        marginTop: "mt-60",
        width: "w-96",
        minWidth: "min-w-min",
        closeOnBackgroundClick: false
      }, {
        title: withCtx(() => [
          createBaseVNode("legend", _hoisted_1, toDisplayString(unref(upperCaseWord)(props.mode)) + " File System", 1)
        ]),
        content: withCtx(() => [
          createBaseVNode("div", _hoisted_2, [
            props.mode == "unlock" ? (openBlock(), createElementBlock("div", _hoisted_3, [
              createBaseVNode("div", _hoisted_4, [
                createBaseVNode("label", {
                  for: getIdKey("filesystem-name"),
                  class: normalizeClass([unref(truncateText), "mt-1 block text-sm font-medium leading-6 text-default"]),
                  title: props.filesystem.name
                }, [
                  _cache[9] || (_cache[9] = createTextVNode("Name: ")),
                  createBaseVNode("span", {
                    class: normalizeClass([unref(truncateText), "font-normal"]),
                    title: props.filesystem.name
                  }, toDisplayString(props.filesystem.name), 11, _hoisted_6)
                ], 10, _hoisted_5)
              ]),
              createBaseVNode("div", _hoisted_7, [
                createBaseVNode("div", _hoisted_8, [
                  createBaseVNode("label", {
                    for: getIdKey("passphrase"),
                    class: "mt-1 block text-sm font-medium leading-6 text-default"
                  }, "Passphrase", 8, _hoisted_9),
                  showPassword.value == false ? withDirectives((openBlock(), createElementBlock("input", {
                    key: 0,
                    id: getIdKey("passphrase-hidden"),
                    type: "password",
                    onKeydown: _cache[0] || (_cache[0] = withKeys(($event) => confirmBtn(), ["enter"])),
                    "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => passphrase.value = $event),
                    name: "passphrase",
                    class: "mt-1 block w-fit input-textlike bg-default",
                    placeholder: "Enter here"
                  }, null, 40, _hoisted_10)), [
                    [vModelText, passphrase.value]
                  ]) : createCommentVNode("", true),
                  showPassword.value == true ? withDirectives((openBlock(), createElementBlock("input", {
                    key: 1,
                    id: getIdKey("passphrase-shown"),
                    type: "text",
                    onKeydown: _cache[2] || (_cache[2] = withKeys(($event) => confirmBtn(), ["enter"])),
                    "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => passphrase.value = $event),
                    name: "passphrase",
                    class: "mt-1 block w-fit input-textlike bg-default",
                    placeholder: "Enter here"
                  }, null, 40, _hoisted_11)), [
                    [vModelText, passphrase.value]
                  ]) : createCommentVNode("", true)
                ]),
                createBaseVNode("div", _hoisted_12, [
                  showPassword.value == true ? (openBlock(), createElementBlock("button", {
                    key: 0,
                    class: "btn btn-secondary max-h-min",
                    onClick: _cache[4] || (_cache[4] = ($event) => showPassword.value = false)
                  }, [
                    createVNode(unref(render), { class: "h-5" })
                  ])) : createCommentVNode("", true),
                  showPassword.value == false ? (openBlock(), createElementBlock("button", {
                    key: 1,
                    class: "btn btn-secondary max-h-min",
                    onClick: _cache[5] || (_cache[5] = ($event) => showPassword.value = true)
                  }, [
                    createVNode(unref(render$1), { class: "h-5" })
                  ])) : createCommentVNode("", true)
                ])
              ]),
              createBaseVNode("div", _hoisted_13, [
                createBaseVNode("p", _hoisted_14, toDisplayString(passFeedback.value), 1)
              ]),
              createBaseVNode("div", _hoisted_15, [
                createBaseVNode("div", _hoisted_16, [
                  createBaseVNode("label", {
                    for: getIdKey("mount-switch"),
                    class: "mt-3 mr-2 block text-sm font-medium text-default whitespace-nowrap"
                  }, "Mount File System", 8, _hoisted_17),
                  createVNode(unref(ue), {
                    modelValue: mountFS.value,
                    "onUpdate:modelValue": _cache[6] || (_cache[6] = ($event) => mountFS.value = $event),
                    id: getIdKey("mount-file-system"),
                    class: normalizeClass([mountFS.value ? "bg-primary" : "bg-accent", "mt-2 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[12] || (_cache[12] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([mountFS.value ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([mountFS.value ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[10] || (_cache[10] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([mountFS.value ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[11] || (_cache[11] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ]),
                createBaseVNode("div", _hoisted_18, [
                  createBaseVNode("label", {
                    for: getIdKey("force-mount-switch"),
                    class: "mt-3 mr-2 block text-sm font-medium text-default whitespace-nowrap"
                  }, "Forcefully Mount File System", 8, _hoisted_19),
                  createVNode(unref(ue), {
                    modelValue: forceMountFS.value,
                    "onUpdate:modelValue": _cache[7] || (_cache[7] = ($event) => forceMountFS.value = $event),
                    id: getIdKey("force-mount-file-system"),
                    class: normalizeClass([forceMountFS.value ? "bg-primary" : "bg-accent", "mt-2 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[15] || (_cache[15] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([forceMountFS.value ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([forceMountFS.value ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[13] || (_cache[13] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([forceMountFS.value ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[14] || (_cache[14] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ])
              ])
            ])) : createCommentVNode("", true),
            props.mode == "lock" ? (openBlock(), createElementBlock("div", _hoisted_20, [
              createBaseVNode("div", _hoisted_21, [
                createBaseVNode("legend", {
                  class: normalizeClass(unref(truncateText)),
                  title: props.filesystem.name
                }, "Lock filesystem " + toDisplayString(props.filesystem.name) + "?", 11, _hoisted_22)
              ])
            ])) : createCommentVNode("", true)
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_23, [
            createBaseVNode("div", _hoisted_24, [
              createBaseVNode("button", {
                onClick: closeModal,
                id: getIdKey("confirm-no"),
                name: "button-no",
                class: "mt-1 btn btn-secondary object-left justify-start h-fit"
              }, "Cancel", 8, _hoisted_25),
              !unref(doingThing) ? (openBlock(), createElementBlock("button", {
                key: 0,
                onClick: _cache[8] || (_cache[8] = ($event) => confirmBtn()),
                id: getIdKey("confirm-yes"),
                name: "button-yes",
                class: "mt-1 btn btn-danger object-right justify-end h-fit"
              }, toDisplayString(unref(upperCaseWord)(props.mode)), 9, _hoisted_26)) : createCommentVNode("", true),
              unref(doingThing) ? (openBlock(), createElementBlock("button", {
                key: 1,
                disabled: "",
                id: getIdKey("confirm-spinner"),
                type: "button",
                class: "btn btn-danger object-right justify-end h-fit"
              }, [
                _cache[16] || (_cache[16] = createBaseVNode("svg", {
                  "aria-hidden": "true",
                  role: "status",
                  class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                  viewBox: "0 0 100 101",
                  fill: "none",
                  xmlns: "http://www.w3.org/2000/svg"
                }, [
                  createBaseVNode("path", {
                    d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                    fill: "currentColor"
                  }),
                  createBaseVNode("path", {
                    d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                    fill: "text-success"
                  })
                ], -1)),
                createTextVNode(" " + toDisplayString(unref(upperCaseWord)(props.mode)) + "ing... ", 1)
              ], 8, _hoisted_27)) : createCommentVNode("", true)
            ])
          ])
        ]),
        _: 1
      }, 8, ["isOpen"]);
    };
  }
});
export {
  _sfc_main as default
};
