import { d as defineComponent, i as inject, c as computed, x as openBlock, y as createElementBlock, z as createBaseVNode, C as normalizeClass, D as unref, E as toDisplayString, Q as createBlock, B as withCtx, A as createVNode, K as render, r as ref, g as getCapacityColor, aC as isBoolOnOff, w as watch, _ as __vitePreload, ao as reactive, v as provide, aD as _sfc_main$4, Z as createTextVNode, J as formatStatus, aE as getTimestampString, V as convertBytesToSize, G as createCommentVNode, O as Fragment, P as renderList, R as resolveDynamicComponent, $ as upperCaseWord, ax as withDirectives, aF as vModelSelect, aG as vModelText, aH as _sfc_main$5, p as pushNotification, N as Notification, aI as configurePool } from "./index.2c5b72b5.js";
import { _ as _sfc_main$3 } from "./Card.vue_vue_type_script_setup_true_lang.498b3fc7.js";
import { u as ue } from "./switch.b6b8ef92.js";
const _hoisted_1$2 = { class: "flex flex-row justify-between items-center min-w-max w-full px-2 bg-default rounded-2xl h-20 mt-2" };
const _hoisted_2$2 = { class: "flex basis-2/3 flex-col min-w-0 ml-8" };
const _hoisted_3$2 = ["title"];
const _hoisted_4$2 = { class: "flex basis-1/3 items-center justify-center overflow-visible bg-default rounded-full" };
const _hoisted_5$2 = {
  class: "w-32 h-32 transform translate-x-1 translate-y-1",
  "aria-hidden": "true"
};
const _hoisted_6$2 = ["id", "stroke-width", "r", "cx", "cy"];
const _hoisted_7$1 = ["id", "stroke-width", "stroke-dasharray", "stroke-dashoffset", "r", "cx", "cy"];
const _sfc_main$2 = /* @__PURE__ */ defineComponent({
  __name: "PoolCapacity",
  props: {
    id: {},
    fillColor: {},
    radius: {},
    coordX: {},
    coordY: {},
    strokeWidth: {},
    percentage: {},
    name: {},
    totalSize: {},
    percentFontSize: {}
  },
  setup(__props) {
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const circumference = computed(() => {
      const radius = props.radius;
      return 2 * Math.PI * radius;
    });
    const offset = computed(() => {
      const percentage = props.percentage;
      return circumference.value - circumference.value * percentage / 100;
    });
    const getIdKey = (name) => `${name}`;
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1$2, [
        createBaseVNode("div", _hoisted_2$2, [
          createBaseVNode("p", {
            class: normalizeClass(["mr-auto font-medium text-default text-xl max-w-sm", unref(truncateText)]),
            title: props.name
          }, toDisplayString(props.name), 11, _hoisted_3$2),
          createBaseVNode("span", {
            class: normalizeClass(["mr-auto text-xl font-medium hidden sm:block", props.fillColor])
          }, toDisplayString(props.totalSize), 3)
        ]),
        createBaseVNode("div", _hoisted_4$2, [
          (openBlock(), createElementBlock("svg", _hoisted_5$2, [
            createBaseVNode("circle", {
              id: getIdKey("circle-empty"),
              class: "text-gray-300 dark:text-gray-500",
              "stroke-width": props.strokeWidth,
              stroke: "currentColor",
              fill: "transparent",
              r: props.radius,
              cx: props.coordX,
              cy: props.coordY
            }, null, 8, _hoisted_6$2),
            createBaseVNode("circle", {
              id: getIdKey("circle-filled"),
              class: normalizeClass(props.fillColor),
              "stroke-width": props.strokeWidth,
              "stroke-dasharray": circumference.value,
              "stroke-dashoffset": offset.value,
              "stroke-linecap": "round",
              stroke: "currentColor",
              fill: "transparent",
              r: props.radius,
              cx: props.coordX,
              cy: props.coordY
            }, null, 10, _hoisted_7$1)
          ])),
          createBaseVNode("span", {
            class: normalizeClass(["absolute", props.percentFontSize, props.fillColor])
          }, toDisplayString(props.percentage) + "%", 3)
        ])
      ]);
    };
  }
});
const _hoisted_1$1 = { class: "flex flex-row justify-between gap-1" };
const _hoisted_2$1 = ["title"];
const _hoisted_3$1 = { class: "px-1" };
const _hoisted_4$1 = { class: "text-success" };
const _hoisted_5$1 = { class: "text-default" };
const _hoisted_6$1 = { class: "text-default" };
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "PoolDetailDiskCard",
  props: {
    disk: {}
  },
  setup(__props) {
    const truncateText = inject("style-truncate-text");
    const props = __props;
    return (_ctx, _cache) => {
      return openBlock(), createBlock(_sfc_main$3, {
        bgColor: "bg-default",
        titleSection: true,
        contentSection: true,
        footerSection: true,
        class: "mt-2 mb-4 overflow-visible card bg-default",
        title: props.disk.name
      }, {
        title: withCtx(() => [
          createBaseVNode("div", _hoisted_1$1, [
            createBaseVNode("div", {
              class: normalizeClass(["pr-2 text-default text-medium", unref(truncateText)]),
              title: props.disk.name
            }, toDisplayString(props.disk.name), 11, _hoisted_2$1),
            createBaseVNode("div", _hoisted_3$1, [
              createVNode(unref(render), { class: "aspect-square w-5 h-5 text-green-400" })
            ])
          ])
        ]),
        content: withCtx(() => [
          createBaseVNode("div", null, [
            createBaseVNode("p", null, "(" + toDisplayString(props.disk.type) + ")", 1),
            createBaseVNode("span", _hoisted_4$1, toDisplayString(props.disk.health), 1)
          ]),
          createBaseVNode("div", null, [
            createBaseVNode("span", _hoisted_5$1, toDisplayString(props.disk.temp) + "\xA0", 1)
          ])
        ]),
        footer: withCtx(() => [
          createBaseVNode("div", _hoisted_6$1, [
            createBaseVNode("b", null, "Total: " + toDisplayString(props.disk.capacity), 1)
          ])
        ]),
        _: 1
      }, 8, ["title"]);
    };
  }
});
const _hoisted_1 = { key: 0 };
const _hoisted_2 = { class: "mt-6 grid grid-cols-3 grid-rows-2 text-default" };
const _hoisted_3 = { class: "mt-2 px-8 col-span-3 row-start-2 grid grid-cols-3 justify-items-center min-w-fit max-w-fit" };
const _hoisted_4 = { class: "m-2 col-span-1" };
const _hoisted_5 = ["id"];
const _hoisted_6 = ["id"];
const _hoisted_7 = ["id"];
const _hoisted_8 = { class: "m-2 col-span-1" };
const _hoisted_9 = ["id", "title"];
const _hoisted_10 = ["id"];
const _hoisted_11 = ["id"];
const _hoisted_12 = { class: "m-2 col-span-1" };
const _hoisted_13 = ["id"];
const _hoisted_14 = ["id"];
const _hoisted_15 = ["id"];
const _hoisted_16 = ["id"];
const _hoisted_17 = { class: "mb-1 text-base font-medium leading-6 text-default" };
const _hoisted_18 = {
  key: 2,
  class: "w-full text-center min-w-fit"
};
const _hoisted_19 = { key: 3 };
const _hoisted_20 = { class: "grid grid-cols-4 gap-2" };
const _hoisted_21 = { class: "mt-2 col-span-1 col-start-1 row-start-1" };
const _hoisted_22 = ["id"];
const _hoisted_23 = ["title"];
const _hoisted_24 = { class: "mt-2 col-span-1 col-start-2 row-start-1" };
const _hoisted_25 = ["id"];
const _hoisted_26 = { class: "mt-1 py-1.5" };
const _hoisted_27 = { class: "mt-2 col-span-1 col-start-3 row-start-1" };
const _hoisted_28 = ["id"];
const _hoisted_29 = { class: "mt-1 py-1.5" };
const _hoisted_30 = { class: "mt-2 col-span-1 col-start-4 row-start-1" };
const _hoisted_31 = ["for"];
const _hoisted_32 = ["id"];
const _hoisted_33 = { class: "mt-2 col-span-1 col-start-1 row-start-2" };
const _hoisted_34 = ["for"];
const _hoisted_35 = ["id"];
const _hoisted_36 = { class: "mt-2 col-span-3 col-start-2 row-start-2" };
const _hoisted_37 = ["for"];
const _hoisted_38 = ["id"];
const _hoisted_39 = { class: "col-span-1 col-start-1 row-start-3" };
const _hoisted_40 = ["for"];
const _hoisted_41 = { class: "col-span-1 col-start-2 row-start-3" };
const _hoisted_42 = ["for"];
const _hoisted_43 = { class: "col-span-2 col-start-3 row-start-3" };
const _hoisted_44 = ["for"];
const _hoisted_45 = { class: "col-span-2 col-start-1 row-start-4" };
const _hoisted_46 = { class: "col-span-1 flex flex-row gap-2 mt-1 text-center leading-6" };
const _hoisted_47 = ["for"];
const _hoisted_48 = {
  key: 0,
  class: "col-span-1 col-start-3 row-start-4"
};
const _hoisted_49 = ["for"];
const _hoisted_50 = { class: "button-group-row w-full justify-between" };
const _hoisted_51 = { class: "mt-2 justify-self-start" };
const _hoisted_52 = ["id"];
const _hoisted_53 = { class: "justofy-self-center" };
const _hoisted_54 = { class: "button-group-row mt-2 justify-self-center" };
const _hoisted_55 = {
  key: 0,
  class: "text-danger"
};
const _hoisted_56 = { class: "justify-self-end" };
const _hoisted_57 = { key: 0 };
const _hoisted_58 = { class: "mt-2" };
const _hoisted_59 = ["id"];
const _hoisted_60 = { key: 1 };
const _hoisted_61 = { class: "mt-2" };
const _hoisted_62 = ["id"];
const _hoisted_63 = { key: 2 };
const _hoisted_64 = { class: "button-group-row mt-2" };
const _hoisted_65 = ["id"];
const _hoisted_66 = {
  key: 1,
  disabled: "",
  id: "finish",
  type: "button",
  class: "btn btn-primary object-right justify-end"
};
const _hoisted_67 = { key: 0 };
const _hoisted_68 = { key: 1 };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "PoolDetail",
  props: {
    pool: {},
    confirmation: {},
    showFlag: { type: Boolean }
  },
  emits: ["close"],
  setup(__props, { emit: __emit }) {
    const emit = __emit;
    const closeModal = () => {
      emit("close");
    };
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const poolConfig = ref({
      name: props.pool.name,
      status: props.pool.status,
      guid: props.pool.guid,
      properties: {
        rawsize: props.pool.properties.rawsize,
        size: props.pool.properties.size,
        allocated: props.pool.properties.allocated,
        capacity: props.pool.properties.capacity,
        free: props.pool.properties.free,
        sector: props.pool.properties.sector,
        record: props.pool.properties.record,
        compression: props.pool.properties.compression,
        deduplication: props.pool.properties.deduplication,
        refreservationPercent: props.pool.properties.refreservationPercent,
        autoExpand: props.pool.properties.autoExpand,
        autoReplace: props.pool.properties.autoReplace,
        autoTrim: props.pool.properties.autoTrim,
        forceCreate: props.pool.properties.forceCreate,
        delegation: props.pool.properties.delegation,
        listSnapshots: props.pool.properties.listSnapshots,
        readOnly: props.pool.properties.readOnly,
        available: props.pool.properties.available
      },
      vdevs: props.pool.vdevs,
      failMode: props.pool.failMode,
      comment: props.pool.comment,
      statusCode: props.pool.statusCode,
      statusDetail: props.pool.statusDetail,
      errorCount: props.pool.errorCount
    });
    const capacityColor = computed(
      () => getCapacityColor("text", props.pool.properties.capacity, props.pool.properties.refreservationPercent)
    );
    inject("pools");
    inject("disks");
    inject("disks-loaded");
    inject("pools-loaded");
    inject("scan-object-group");
    inject("pool-disk-stats");
    inject("scan-activities");
    inject("trim-activities");
    const snapshots = inject("snapshots");
    const snapshotListComponent = ref();
    const showPoolDetails = inject("show-pool-deets");
    const getNumDevices = props.pool.vdevs.length;
    const getNumDisks = computed(() => {
      let disks2 = 0;
      props.pool.vdevs.forEach((vdev) => {
        vdev.disks.forEach((disk) => {
          disks2++;
        });
      });
      return disks2;
    });
    function calculateSectorSize(exponent) {
      const bytes = Math.pow(2, exponent);
      const result = ref("");
      if (bytes > 1024) {
        const kiB = bytes / 1024;
        result.value = `${kiB} KiB`;
      } else {
        result.value = `${bytes} B`;
      }
      return result.value;
    }
    const operationRunning = ref(false);
    const firstOptionToggle = ref(false);
    const secondOptionToggle = ref(false);
    const thirdOptionToggle = ref(false);
    const fourthOptionToggle = ref(false);
    const showAddVDevModal = ref(false);
    const addVDevComponent = ref();
    const loadAddVDevComponent = async () => {
      const module = await __vitePreload(() => import("./AddVDevModal.cc256abe.js"), true ? ["./AddVDevModal.cc256abe.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./loadImportables.482e66e9.js","./ExclamationTriangleIcon.128ffceb.js","./switch.b6b8ef92.js","./AddVDevModal.2b382f5f.css"] : void 0, import.meta.url);
      addVDevComponent.value = module.default;
    };
    async function addVDevButton() {
      await loadAddVDevComponent();
      showAddVDevModal.value = true;
    }
    const updateShowAddVDev = (newVal) => {
      showAddVDevModal.value = newVal;
    };
    const showSnapshotModal = ref(false);
    const creating = ref(false);
    const confirmCreate = ref(false);
    const createSnapshotComponent = ref();
    const loadCreateSnapshotComponent = async () => {
      const module = await __vitePreload(() => import("./CreateSnapshotModal.85f1f9ce.js"), true ? ["./CreateSnapshotModal.85f1f9ce.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./switch.b6b8ef92.js"] : void 0, import.meta.url);
      createSnapshotComponent.value = module.default;
    };
    async function createSnapshotBtn() {
      await loadCreateSnapshotComponent();
      showSnapshotModal.value = true;
    }
    const updateShowNewSnapshot = (newVal) => {
      showSnapshotModal.value = newVal;
    };
    const saving = ref(false);
    const commentFeedback = ref("");
    const newChangesToPool = ref({
      name: poolConfig.value.name,
      guid: poolConfig.value.guid,
      readonly: isBoolOnOff(poolConfig.value.properties.readOnly)
    });
    ({
      name: poolConfig.value.name,
      guid: poolConfig.value.guid,
      readonly: isBoolOnOff(poolConfig.value.properties.readOnly)
    });
    async function checkForChanges() {
      const changes = {};
      if (poolConfig.value.failMode !== props.pool.failMode)
        changes.failmode = poolConfig.value.failMode;
      if (poolConfig.value.comment !== props.pool.comment)
        changes.comment = poolConfig.value.comment;
      if (poolConfig.value.properties.autoExpand !== props.pool.properties.autoExpand)
        changes.autoexpand = isBoolOnOff(poolConfig.value.properties.autoExpand);
      if (poolConfig.value.properties.autoReplace !== props.pool.properties.autoReplace)
        changes.autoreplace = isBoolOnOff(poolConfig.value.properties.autoReplace);
      if (poolConfig.value.properties.autoTrim !== props.pool.properties.autoTrim)
        changes.autotrim = isBoolOnOff(poolConfig.value.properties.autoTrim);
      if (poolConfig.value.properties.delegation !== props.pool.properties.delegation)
        changes.delegation = isBoolOnOff(poolConfig.value.properties.delegation);
      if (poolConfig.value.properties.listSnapshots !== props.pool.properties.listSnapshots)
        changes.listsnapshots = isBoolOnOff(poolConfig.value.properties.listSnapshots);
      newChangesToPool.value = { ...newChangesToPool.value, ...changes };
      return Object.keys(changes).length > 0;
    }
    const commentLengthCheck = (poolData) => {
      let result = true;
      commentFeedback.value = "";
      if (poolData.comment.length > 32) {
        result = false;
        commentFeedback.value = "Comment cannot exceed 32 characters.";
      }
      return result;
    };
    const confirmSavePool = inject("confirm-save-pool");
    async function poolConfigureBtn() {
      if (commentLengthCheck(poolConfig.value)) {
        if (!await checkForChanges()) {
          pushNotification(new Notification("No Changes", "No modifications detected in the pool configuration.", "info", 5e3));
          showPoolDetails.value = false;
          return;
        }
        saving.value = true;
        try {
          const result = await configurePool(newChangesToPool.value);
          if (result.success === false) {
            pushNotification(new Notification("Save Pool Config Failed", `There was an error saving this pool: ${result.error || "Unknown error occurred"}.`, "error", 5e3));
            confirmSavePool.value = false;
          } else if (result.success === true) {
            confirmSavePool.value = true;
            showPoolDetails.value = false;
          }
        } catch (error) {
          pushNotification(new Notification("Operation Failed", `An unexpected error occurred: ${error.message}`, "error", 5e3));
        } finally {
          saving.value = false;
        }
      }
    }
    const navTag = ref("stats");
    const show = ref(true);
    const currentNavigationItem = computed(() => navigation.find((item) => item.current));
    const navigationCallback = (item) => {
      navTag.value = item.tag;
    };
    watch(navTag, (newVal, oldVal) => {
      if (navTag.value == "snapshots") {
        __vitePreload(() => import("./SnapshotsList.f888f4cc.js"), true ? ["./SnapshotsList.f888f4cc.js","./SnapshotsList.vue_vue_type_script_setup_true_lang.75e9a913.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./LoadingSpinner.vue_vue_type_script_setup_true_lang.38ea0b01.js"] : void 0, import.meta.url).then((module) => {
          snapshotListComponent.value = module.default;
        });
      }
    }, { immediate: true });
    const navigation = reactive([
      { name: "Stats", tag: "stats", current: computed(() => navTag.value == "stats"), show: true },
      { name: "Topology", tag: "topology", current: computed(() => navTag.value == "topology"), show: true },
      { name: "Snapshots", tag: "snapshots", current: computed(() => navTag.value == "snapshots"), show: true },
      { name: "Settings", tag: "settings", current: computed(() => navTag.value == "settings"), show: true }
    ].filter((item) => item.show));
    const getIdKey = (name) => `${name}`;
    provide("create-snap-modal", showSnapshotModal);
    provide("current-pool-config", poolConfig);
    provide("show-vdev-modal", showAddVDevModal);
    provide("saving", saving);
    provide("create-snap-modal", showSnapshotModal);
    provide("snapshots", snapshots);
    provide("confirm-create-snap", confirmCreate);
    provide("creating", creating);
    provide("modal-confirm-running", operationRunning);
    provide("modal-option-one-toggle", firstOptionToggle);
    provide("modal-option-two-toggle", secondOptionToggle);
    provide("modal-option-three-toggle", thirdOptionToggle);
    provide("modal-option-four-toggle", fourthOptionToggle);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(Fragment, null, [
        createVNode(_sfc_main$5, {
          onClose: closeModal,
          "close-on-background-click": false,
          isOpen: unref(showPoolDetails),
          marginTop: "mt-28",
          width: "w-7/12",
          minWidth: "min-w-7/12",
          initialFocus: null
        }, {
          title: withCtx(() => [
            createVNode(_sfc_main$4, {
              navigationItems: navigation,
              currentNavigationItem: currentNavigationItem.value,
              navigationCallback,
              show: show.value
            }, null, 8, ["navigationItems", "currentNavigationItem", "show"])
          ]),
          content: withCtx(() => [
            navTag.value == "stats" ? (openBlock(), createElementBlock("div", _hoisted_1, [
              createBaseVNode("div", _hoisted_2, [
                createVNode(_sfc_main$2, {
                  id: getIdKey("pool-visual-capacity"),
                  fillColor: capacityColor.value,
                  name: props.pool.name,
                  totalSize: props.pool.properties.size,
                  percentage: props.pool.properties.capacity,
                  radius: 50,
                  coordX: 60,
                  coordY: 60,
                  strokeWidth: 10,
                  percentFontSize: "text-2xl",
                  class: "w-full col-span-3 grow"
                }, null, 8, ["id", "fillColor", "name", "totalSize", "percentage"]),
                createBaseVNode("div", _hoisted_3, [
                  createBaseVNode("div", _hoisted_4, [
                    createBaseVNode("p", {
                      id: getIdKey("pool-health"),
                      name: "pool-health",
                      class: "text-lg"
                    }, [
                      _cache[11] || (_cache[11] = createTextVNode("Health: ")),
                      createBaseVNode("span", {
                        class: normalizeClass([unref(formatStatus)(props.pool.status), ""])
                      }, toDisplayString(props.pool.status), 3)
                    ], 8, _hoisted_5),
                    createBaseVNode("p", {
                      id: getIdKey("pool-errors"),
                      name: "pool-errors",
                      class: "text-sm"
                    }, [
                      _cache[12] || (_cache[12] = createTextVNode("Errors: ")),
                      createBaseVNode("span", {
                        class: normalizeClass([unref(formatStatus)(props.pool.status), ""])
                      }, toDisplayString(props.pool.errorCount), 3),
                      _cache[13] || (_cache[13] = createBaseVNode("br", null, null, -1)),
                      createTextVNode("as of " + toDisplayString(unref(getTimestampString)()), 1)
                    ], 8, _hoisted_6),
                    createBaseVNode("p", {
                      id: getIdKey("pool-refreservation"),
                      name: "pool-refreservation",
                      class: "text-sm"
                    }, " Refreservation: " + toDisplayString(unref(convertBytesToSize)(props.pool.properties.refreservationRawSize)) + " (" + toDisplayString(unref(convertBytesToSize)(props.pool.properties.refreservationRawSize)) + " (" + toDisplayString(props.pool.properties.refreservationPercent) + "%)", 9, _hoisted_7)
                  ]),
                  createBaseVNode("div", _hoisted_8, [
                    createBaseVNode("p", {
                      id: getIdKey("pool-altroot"),
                      name: "pool-altroot",
                      class: normalizeClass(["text-base", unref(truncateText)]),
                      title: props.pool.properties.altroot == "" || props.pool.properties.altroot == "-" ? "None" : props.pool.properties.altroot
                    }, "Alt Root: " + toDisplayString(props.pool.properties.altroot == "" || props.pool.properties.altroot == "-" ? "None" : props.pool.properties.altroot), 11, _hoisted_9),
                    createBaseVNode("p", {
                      id: getIdKey("pool-devices"),
                      name: "pool-devices",
                      class: "text-base"
                    }, "Devices: " + toDisplayString(unref(getNumDevices)), 9, _hoisted_10),
                    createBaseVNode("p", {
                      id: getIdKey("pool-disks"),
                      name: "pool-disks",
                      class: "text-base"
                    }, "Disks: " + toDisplayString(getNumDisks.value), 9, _hoisted_11)
                  ]),
                  createBaseVNode("div", _hoisted_12, [
                    createBaseVNode("p", {
                      id: getIdKey("pool-allocated"),
                      name: "pool-allocated",
                      class: "text-base"
                    }, "Used: " + toDisplayString(props.pool.properties.allocated), 9, _hoisted_13),
                    createBaseVNode("p", {
                      id: getIdKey("pool-free"),
                      name: "pool-free",
                      class: "text-base"
                    }, "RAW Space Available: " + toDisplayString(props.pool.properties.free), 9, _hoisted_14),
                    createBaseVNode("p", {
                      id: getIdKey("pool-free"),
                      name: "pool-free",
                      class: "text-base"
                    }, "Actual Space Available: " + toDisplayString(props.pool.properties.available), 9, _hoisted_15),
                    createBaseVNode("p", {
                      id: getIdKey("pool-size"),
                      name: "pool-size",
                      class: "text-base"
                    }, "Total: " + toDisplayString(props.pool.properties.size), 9, _hoisted_16)
                  ])
                ])
              ])
            ])) : createCommentVNode("", true),
            navTag.value == "topology" ? (openBlock(), createElementBlock("div", {
              key: 1,
              class: normalizeClass(["mt-2 grid", `grid-cols-${props.pool.vdevs.length}`])
            }, [
              (openBlock(true), createElementBlock(Fragment, null, renderList(props.pool.vdevs, (vDev, vDevIdx) => {
                return openBlock(), createElementBlock("div", {
                  key: vDevIdx,
                  class: "p-2 m-2 rounded-md border border-default bg-accent"
                }, [
                  createBaseVNode("legend", _hoisted_17, toDisplayString(vDev.name) + " (" + toDisplayString(vDev.type) + ") ", 1),
                  createBaseVNode("div", {
                    class: normalizeClass(["grid", vDev.disks.length < 2 ? "grid-cols-1" : "grid-cols-2"])
                  }, [
                    (openBlock(true), createElementBlock(Fragment, null, renderList(vDev.disks, (disk, diskIdx) => {
                      return openBlock(), createElementBlock("div", {
                        key: diskIdx,
                        class: "m-1"
                      }, [
                        createVNode(_sfc_main$1, {
                          disk: vDev.disks[diskIdx]
                        }, null, 8, ["disk"])
                      ]);
                    }), 128))
                  ], 2)
                ]);
              }), 128))
            ], 2)) : createCommentVNode("", true),
            navTag.value == "snapshots" ? (openBlock(), createElementBlock("div", _hoisted_18, [
              (openBlock(), createBlock(resolveDynamicComponent(snapshotListComponent.value), {
                pool: props.pool,
                item: "pool"
              }, null, 8, ["pool"]))
            ])) : createCommentVNode("", true),
            navTag.value == "settings" ? (openBlock(), createElementBlock("div", _hoisted_19, [
              createBaseVNode("div", _hoisted_20, [
                createBaseVNode("div", _hoisted_21, [
                  createBaseVNode("p", {
                    id: getIdKey("settings-pool-name"),
                    name: "settings-pool-name",
                    class: "text-base text-default"
                  }, "Pool", 8, _hoisted_22),
                  createBaseVNode("p", {
                    class: normalizeClass(["mt-1 py-1.5", unref(truncateText)]),
                    title: poolConfig.value.name
                  }, toDisplayString(poolConfig.value.name), 11, _hoisted_23)
                ]),
                createBaseVNode("div", _hoisted_24, [
                  createBaseVNode("p", {
                    id: getIdKey("settings-pool-readonly"),
                    name: "settings-pool-readonly",
                    class: "text-base text-default"
                  }, "Read Only", 8, _hoisted_25),
                  createBaseVNode("p", _hoisted_26, toDisplayString(unref(upperCaseWord)(unref(isBoolOnOff)(poolConfig.value.properties.readOnly))), 1)
                ]),
                createBaseVNode("div", _hoisted_27, [
                  createBaseVNode("p", {
                    id: getIdKey("settings-pool-guid"),
                    name: "settings-pool-guid",
                    class: "text-base text-default"
                  }, "GUID", 8, _hoisted_28),
                  createBaseVNode("p", _hoisted_29, toDisplayString(poolConfig.value.guid), 1)
                ]),
                createBaseVNode("div", _hoisted_30, [
                  createBaseVNode("label", {
                    for: getIdKey("settings-pool-sector-size"),
                    class: "bg-default block text-base leading-6 text-default"
                  }, "Sector Size", 8, _hoisted_31),
                  createBaseVNode("p", {
                    id: getIdKey("settings-pool-sector-size"),
                    name: "settings-pool-sector-size",
                    class: "mt-1 py-1.5"
                  }, toDisplayString(calculateSectorSize(Number(poolConfig.value.properties.sector))), 9, _hoisted_32)
                ]),
                createBaseVNode("div", _hoisted_33, [
                  createBaseVNode("label", {
                    for: getIdKey("settings-pool-fail-mode"),
                    class: "bg-default block text-base leading-6 text-default"
                  }, "Fail Mode", 8, _hoisted_34),
                  withDirectives(createBaseVNode("select", {
                    id: getIdKey("settings-pool-fail-mode"),
                    "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => poolConfig.value.failMode = $event),
                    name: "pool-fail-mode",
                    class: "mt-1 block w-full rounded-md border-0 py-1.5 text-default bg-default ring-1 ring-inset ring-gray-300 focus:ring-2 focus:ring-slate-600 sm:text-sm sm:leading-6"
                  }, _cache[14] || (_cache[14] = [
                    createBaseVNode("option", { value: "wait" }, "Wait", -1),
                    createBaseVNode("option", { value: "continue" }, "Continue", -1),
                    createBaseVNode("option", { value: "panic" }, "Panic", -1)
                  ]), 8, _hoisted_35), [
                    [vModelSelect, poolConfig.value.failMode]
                  ])
                ]),
                createBaseVNode("div", _hoisted_36, [
                  createBaseVNode("p", {
                    for: getIdKey("settings-pool-comment"),
                    class: "text-base text-default"
                  }, "Comment", 8, _hoisted_37),
                  withDirectives(createBaseVNode("input", {
                    id: getIdKey("settings-pool-comment"),
                    "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => poolConfig.value.comment = $event),
                    name: "setting-pool-comment",
                    placeholder: "Enter a comment here",
                    type: "text",
                    class: "input-textlike mt-1 block w-full rounded-md border-0 py-1.5 px-1.5 text-default shadow-sm ring-1 ring-inset ring-gray-300 placeholder:text-muted focus:ring-2 focus:ring-inset focus:ring-slate-300 sm:text-sm sm:leading-6"
                  }, null, 8, _hoisted_38), [
                    [vModelText, poolConfig.value.comment]
                  ])
                ]),
                createBaseVNode("div", _hoisted_39, [
                  createBaseVNode("label", {
                    for: getIdKey("settings-pool-auto-expand"),
                    class: "mt-1 block text-sm leading-6 text-default"
                  }, "Auto-Expand Pool", 8, _hoisted_40),
                  createVNode(unref(ue), {
                    modelValue: poolConfig.value.properties.autoExpand,
                    "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => poolConfig.value.properties.autoExpand = $event),
                    id: getIdKey("settings-pool-auto-expand"),
                    class: normalizeClass([poolConfig.value.properties.autoExpand ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[17] || (_cache[17] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([poolConfig.value.properties.autoExpand ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.autoExpand ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[15] || (_cache[15] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.autoExpand ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[16] || (_cache[16] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ]),
                createBaseVNode("div", _hoisted_41, [
                  createBaseVNode("label", {
                    for: getIdKey("settings-pool-auto-replace"),
                    class: "mt-1 block text-sm leading-6 text-default"
                  }, "Auto-Replace Drives", 8, _hoisted_42),
                  createVNode(unref(ue), {
                    modelValue: poolConfig.value.properties.autoReplace,
                    "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => poolConfig.value.properties.autoReplace = $event),
                    id: getIdKey("settings-pool-auto-replace"),
                    class: normalizeClass([poolConfig.value.properties.autoReplace ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[20] || (_cache[20] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([poolConfig.value.properties.autoReplace ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.autoReplace ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[18] || (_cache[18] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.autoReplace ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[19] || (_cache[19] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ]),
                createBaseVNode("div", _hoisted_43, [
                  createBaseVNode("label", {
                    for: getIdKey("settings-pool-display-snapshots"),
                    class: "mt-1 block text-sm leading-6 text-default"
                  }, "List Snapshots With File Systems", 8, _hoisted_44),
                  createVNode(unref(ue), {
                    modelValue: poolConfig.value.properties.listSnapshots,
                    "onUpdate:modelValue": _cache[4] || (_cache[4] = ($event) => poolConfig.value.properties.listSnapshots = $event),
                    id: getIdKey("settings-pool-display-snapshots"),
                    class: normalizeClass([poolConfig.value.properties.listSnapshots ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[23] || (_cache[23] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([poolConfig.value.properties.listSnapshots ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.listSnapshots ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[21] || (_cache[21] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.listSnapshots ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[22] || (_cache[22] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ]),
                createBaseVNode("div", _hoisted_45, [
                  createBaseVNode("div", _hoisted_46, [
                    createBaseVNode("label", {
                      for: getIdKey("settings-pool-delegation"),
                      class: "block text-sm text-default"
                    }, "Delegation", 8, _hoisted_47),
                    _cache[24] || (_cache[24] = createBaseVNode("p", { class: "text-xs text-muted mt-0.5" }, "(Access based on dataset permissions)", -1))
                  ]),
                  createVNode(unref(ue), {
                    initialFocus: null,
                    modelValue: poolConfig.value.properties.delegation,
                    "onUpdate:modelValue": _cache[5] || (_cache[5] = ($event) => poolConfig.value.properties.delegation = $event),
                    id: getIdKey("settings-pool-delegation"),
                    class: normalizeClass([poolConfig.value.properties.delegation ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[27] || (_cache[27] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([poolConfig.value.properties.delegation ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.delegation ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[25] || (_cache[25] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.delegation ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[26] || (_cache[26] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ]),
                props.pool.diskType == "SSD" || props.pool.diskType == "Hybrid" ? (openBlock(), createElementBlock("div", _hoisted_48, [
                  createBaseVNode("label", {
                    for: getIdKey("settings-pool-auto-trim"),
                    class: "mt-1 block text-sm leading-6 text-default"
                  }, "Auto-TRIM Pool", 8, _hoisted_49),
                  createVNode(unref(ue), {
                    modelValue: poolConfig.value.properties.autoTrim,
                    "onUpdate:modelValue": _cache[6] || (_cache[6] = ($event) => poolConfig.value.properties.autoTrim = $event),
                    id: getIdKey("settings-pool-auto-trim"),
                    class: normalizeClass([poolConfig.value.properties.autoTrim ? "bg-secondary" : "bg-accent", "mt-1 relative inline-flex h-6 w-11 flex-shrink-0 cursor-pointer rounded-full border-2 border-transparent transition-colors duration-200 ease-in-out focus:outline-none focus:ring-2 focus:ring-slate-600 focus:ring-offset-2"])
                  }, {
                    default: withCtx(() => [
                      _cache[30] || (_cache[30] = createBaseVNode("span", { class: "sr-only" }, "Use setting", -1)),
                      createBaseVNode("span", {
                        class: normalizeClass([poolConfig.value.properties.autoTrim ? "translate-x-5" : "translate-x-0", "pointer-events-none relative inline-block h-5 w-5 transform rounded-full bg-default shadow ring-0 transition duration-200 ease-in-out"])
                      }, [
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.autoTrim ? "opacity-0 duration-100 ease-out" : "opacity-100 duration-200 ease-in", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[28] || (_cache[28] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-muted",
                            fill: "none",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", {
                              d: "M4 8l2-2m0 0l2-2M6 6L4 4m2 2l2 2",
                              stroke: "currentColor",
                              "stroke-width": "2",
                              "stroke-linecap": "round",
                              "stroke-linejoin": "round"
                            })
                          ], -1)
                        ]), 2),
                        createBaseVNode("span", {
                          class: normalizeClass([poolConfig.value.properties.autoTrim ? "opacity-100 duration-200 ease-in" : "opacity-0 duration-100 ease-out", "absolute inset-0 flex h-full w-full items-center justify-center transition-opacity"]),
                          "aria-hidden": "true"
                        }, _cache[29] || (_cache[29] = [
                          createBaseVNode("svg", {
                            class: "h-3 w-3 text-primary",
                            fill: "currentColor",
                            viewBox: "0 0 12 12"
                          }, [
                            createBaseVNode("path", { d: "M3.707 5.293a1 1 0 00-1.414 1.414l1.414-1.414zM5 8l-.707.707a1 1 0 001.414 0L5 8zm4.707-3.293a1 1 0 00-1.414-1.414l1.414 1.414zm-7.414 2l2 2 1.414-1.414-2-2-1.414 1.414zm3.414 2l4-4-1.414-1.414-4 4 1.414 1.414z" })
                          ], -1)
                        ]), 2)
                      ], 2)
                    ]),
                    _: 1
                  }, 8, ["modelValue", "id", "class"])
                ])) : createCommentVNode("", true)
              ])
            ])) : createCommentVNode("", true)
          ]),
          footer: withCtx(() => [
            createBaseVNode("div", _hoisted_50, [
              createBaseVNode("div", _hoisted_51, [
                createBaseVNode("button", {
                  onClick: _cache[7] || (_cache[7] = ($event) => showPoolDetails.value = false),
                  id: getIdKey("close-details-btn"),
                  name: "close-details-btn",
                  class: "mt-1 btn btn-danger"
                }, "Close", 8, _hoisted_52)
              ]),
              createBaseVNode("div", _hoisted_53, [
                createBaseVNode("div", _hoisted_54, [
                  commentFeedback.value ? (openBlock(), createElementBlock("p", _hoisted_55, toDisplayString(commentFeedback.value), 1)) : createCommentVNode("", true)
                ])
              ]),
              createBaseVNode("div", _hoisted_56, [
                navTag.value == "topology" ? (openBlock(), createElementBlock("div", _hoisted_57, [
                  createBaseVNode("div", _hoisted_58, [
                    createBaseVNode("button", {
                      onClick: _cache[8] || (_cache[8] = ($event) => addVDevButton()),
                      id: getIdKey("add-vdev-btn"),
                      name: "add-vdev-btn",
                      class: "mt-1 btn btn-primary"
                    }, "Add Virtual Device", 8, _hoisted_59)
                  ])
                ])) : createCommentVNode("", true),
                navTag.value == "snapshots" ? (openBlock(), createElementBlock("div", _hoisted_60, [
                  createBaseVNode("div", _hoisted_61, [
                    createBaseVNode("button", {
                      onClick: _cache[9] || (_cache[9] = ($event) => createSnapshotBtn()),
                      id: getIdKey("create-snap-wizard-btn"),
                      name: "create-snap-wizard-btn",
                      class: "mt-1 btn btn-primary"
                    }, "Create Snapshot", 8, _hoisted_62)
                  ])
                ])) : createCommentVNode("", true),
                navTag.value == "settings" ? (openBlock(), createElementBlock("div", _hoisted_63, [
                  createBaseVNode("div", _hoisted_64, [
                    !saving.value ? (openBlock(), createElementBlock("button", {
                      key: 0,
                      onClick: _cache[10] || (_cache[10] = ($event) => {
                        poolConfigureBtn();
                        props.confirmation;
                      }),
                      id: getIdKey("settings-save-btn"),
                      name: "settings-save-btn",
                      class: "mt-1 btn btn-primary"
                    }, "Save Changes", 8, _hoisted_65)) : createCommentVNode("", true),
                    saving.value ? (openBlock(), createElementBlock("button", _hoisted_66, _cache[31] || (_cache[31] = [
                      createBaseVNode("svg", {
                        "aria-hidden": "true",
                        role: "status",
                        class: "inline w-4 h-4 mr-3 text-gray-200 animate-spin text-default",
                        viewBox: "0 0 100 101",
                        fill: "none",
                        xmlns: "http://www.w3.org/2000/svg"
                      }, [
                        createBaseVNode("path", {
                          d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
                          fill: "currentColor"
                        }),
                        createBaseVNode("path", {
                          d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
                          fill: "text-success"
                        })
                      ], -1),
                      createTextVNode(" Saving... ")
                    ]))) : createCommentVNode("", true)
                  ])
                ])) : createCommentVNode("", true)
              ])
            ])
          ]),
          _: 1
        }, 8, ["isOpen"]),
        showSnapshotModal.value ? (openBlock(), createElementBlock("div", _hoisted_67, [
          (openBlock(), createBlock(resolveDynamicComponent(createSnapshotComponent.value), {
            onClose: updateShowNewSnapshot,
            poolName: props.pool.name,
            item: "pool"
          }, null, 40, ["poolName"]))
        ])) : createCommentVNode("", true),
        showAddVDevModal.value ? (openBlock(), createElementBlock("div", _hoisted_68, [
          (openBlock(), createBlock(resolveDynamicComponent(addVDevComponent.value), {
            onClose: updateShowAddVDev,
            key: showAddVDevModal.value,
            idKey: getIdKey(`show-vdev-modal`),
            pool: poolConfig.value,
            marginTop: "mt-48"
          }, null, 40, ["idKey", "pool"]))
        ])) : createCommentVNode("", true)
      ], 64);
    };
  }
});
export {
  _sfc_main as default
};
