import { d as defineComponent, i as inject, r as ref, o as onMounted, at as loadSnapshotsInPool, au as loadSnapshotsInDataset, w as watch, av as destroySnapshot, p as pushNotification, N as Notification, aw as rollbackSnapshot, v as provide, x as openBlock, y as createElementBlock, z as createBaseVNode, D as unref, C as normalizeClass, G as createCommentVNode, A as createVNode, O as Fragment, P as renderList, E as toDisplayString, B as withCtx, S as Se, T as Transition, M as Me, a5 as withModifiers, I as be, H as ge, ax as withDirectives, ay as vModelCheckbox, Z as createTextVNode, Q as createBlock, R as resolveDynamicComponent, _ as __vitePreload } from "./index.2c5b72b5.js";
import { _ as _sfc_main$1, r as render } from "./LoadingSpinner.vue_vue_type_script_setup_true_lang.38ea0b01.js";
const _hoisted_1 = { class: "TableDiv" };
const _hoisted_2 = {
  key: 0,
  class: "inline-block min-w-full max-h-96 align-middle border border-default border-collapse overflow-y-auto"
};
const _hoisted_3 = { class: "table-auto min-w-full min-h-full divide-y divide-default" };
const _hoisted_4 = { class: "bg-well border-collapse" };
const _hoisted_5 = {
  key: 0,
  class: "rounded-md grid grid-cols-7 font-semibold text-white"
};
const _hoisted_6 = {
  key: 1,
  class: "grid grid-cols-1 items-center justify-center w-full"
};
const _hoisted_7 = {
  key: 2,
  class: "rounded-md flex bg-well justify-center justify-self-center w-full"
};
const _hoisted_8 = { class: "divide-y divide-default bg-default border-collapse" };
const _hoisted_9 = ["title"];
const _hoisted_10 = ["title"];
const _hoisted_11 = ["title"];
const _hoisted_12 = ["title"];
const _hoisted_13 = ["title"];
const _hoisted_14 = { class: "relative py-1 pl-3 pr-4 text-right text-sm font-medium sm:pr-6 lg:pr-8 col-span-1 justify-self-end" };
const _hoisted_15 = { class: "py-1" };
const _hoisted_16 = ["onClick"];
const _hoisted_17 = ["onClick"];
const _hoisted_18 = ["onClick"];
const _hoisted_19 = {
  key: 0,
  class: "table-auto min-w-full min-h-full divide-y divide-default"
};
const _hoisted_20 = { class: "rounded-md flex bg-well justify-center" };
const _hoisted_21 = {
  key: 1,
  class: "table-auto min-w-full min-h-full divide-y divide-default"
};
const _hoisted_22 = { class: "bg-secondary border-collapse" };
const _hoisted_23 = { class: "rounded-md grid grid-cols-8 font-semibold text-white" };
const _hoisted_24 = {
  key: 3,
  class: "py-2 col-span-1 text-center"
};
const _hoisted_25 = {
  key: 4,
  class: "relative py-2 sm:pr-6 lg:pr-8 rounded-tr-md col-span-1"
};
const _hoisted_26 = { class: "divide-y divide-default bg-accent border-collapse" };
const _hoisted_27 = ["title"];
const _hoisted_28 = ["title"];
const _hoisted_29 = ["title"];
const _hoisted_30 = ["title"];
const _hoisted_31 = ["title"];
const _hoisted_32 = ["title"];
const _hoisted_33 = {
  key: 2,
  class: "text-sm text-default text-center col-span-1 p-0"
};
const _hoisted_34 = ["value"];
const _hoisted_35 = { class: "relative py-1 pl-3 pr-4 text-right text-sm font-medium sm:pr-6 lg:pr-8 col-span-1 justify-self-end" };
const _hoisted_36 = { class: "py-1" };
const _hoisted_37 = ["onClick"];
const _hoisted_38 = ["onClick"];
const _hoisted_39 = ["onClick"];
const _hoisted_40 = ["onClick"];
const _hoisted_41 = ["onClick"];
const _hoisted_42 = {
  key: 3,
  class: "text-center bg-well"
};
const _hoisted_43 = { key: 2 };
const _hoisted_44 = { key: 3 };
const _hoisted_45 = { key: 4 };
const _hoisted_46 = { key: 5 };
const _hoisted_47 = { key: 6 };
const _hoisted_48 = { key: 7 };
const _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "SnapshotsList",
  props: {
    pool: {},
    filesystem: {},
    singleSnap: {},
    item: {},
    bulkSnapDestroyMode: { type: Boolean }
  },
  setup(__props) {
    const props = __props;
    const truncateText = inject("style-truncate-text");
    const snapshotsInPoolLoading = ref(false);
    const snapshotsInDatasetLoaded = ref(false);
    const snapshots = inject("snapshots");
    const snapshotsInFilesystem = ref([]);
    const selectedSnapshot = ref();
    const snapshotNotFound = ref(false);
    onMounted(async () => {
      await refreshSnaps();
    });
    async function refreshSnaps() {
      try {
        if (props.item === "pool") {
          snapshotsInPoolLoading.value = true;
          snapshots.value = [];
          await loadSnapshotsInPool(snapshots, props.pool.name);
        } else if (props.item === "filesystem") {
          snapshotsInFilesystem.value = [];
          await loadSnapshotsInDataset(snapshotsInFilesystem, props.filesystem.name, snapshotNotFound, snapshotsInDatasetLoaded);
        } else if (props.item == "singleSnap") {
          selectedSnapshot.value = snapshots.value.find((snapshot) => snapshot.name == props.singleSnap.name);
        }
      } catch (error) {
        console.error("Failed to load snapshots:", error);
      } finally {
        await new Promise((resolve) => setTimeout(resolve, 1e3));
        console.log(snapshotNotFound.value);
        snapshotsInPoolLoading.value = false;
      }
    }
    const operationRunning = ref(false);
    const firstOptionToggle = ref(false);
    const secondOptionToggle = ref(false);
    const thirdOptionToggle = ref(false);
    const fourthOptionToggle = ref(false);
    const showDestroySnapshotModal = ref(false);
    const hasChildren = ref(false);
    const confirmDestroy = ref(false);
    const destroySnapshotComponent = ref();
    const loadDestroySnapshotComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.6885ab8c.js"), true ? ["./UniversalConfirmation.6885ab8c.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./switch.b6b8ef92.js"] : void 0, import.meta.url);
      destroySnapshotComponent.value = module.default;
    };
    async function destroyThisSnapshot(snapshot) {
      console.log("snapshot: ", snapshot);
      operationRunning.value = false;
      selectedSnapshot.value = snapshot;
      if (selectedSnapshot.value.properties.clones.length > 0) {
        hasChildren.value = true;
      }
      await loadDestroySnapshotComponent();
      showDestroySnapshotModal.value = true;
      console.log("selected for destroy:", selectedSnapshot.value);
    }
    const confirmThisDestroy = () => {
      confirmDestroy.value = true;
    };
    const updateShowDestroySnapshot = (newVal) => {
      showDestroySnapshotModal.value = newVal;
    };
    watch(confirmDestroy, async (newVal, oldVal) => {
      var _a;
      if (confirmDestroy.value == true) {
        operationRunning.value = true;
        console.log("now destroying:", newVal);
        try {
          const output = await destroySnapshot((_a = selectedSnapshot.value) == null ? void 0 : _a.name, firstOptionToggle.value, secondOptionToggle.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            operationRunning.value = false;
            confirmDestroy.value = false;
            pushNotification(new Notification("Destroy Snapshot Failed", `${selectedSnapshot.value.name} was not destroyed: ${errorMessage}`, "error", 5e3));
          } else {
            pushNotification(new Notification("Snapshot Destroyed", `${selectedSnapshot.value.name} destroyed.`, "success", 5e3));
            await refreshSnaps();
            confirmDestroy.value = false;
            operationRunning.value = false;
            hasChildren.value = false;
            console.log("destroyed:", selectedSnapshot.value);
            firstOptionToggle.value = false;
            secondOptionToggle.value = false;
            showDestroySnapshotModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const bulkSnapDestroyMode = inject("bulk-destroy-snaps");
    const selectedForDestroy = ref([]);
    const showDestroyBulkSnapshotModal = ref(false);
    const confirmBulkDestroy = ref(false);
    const destroyBulkSnapshotComponent = ref();
    const loadDestroyBulkSnapshotsComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.6885ab8c.js"), true ? ["./UniversalConfirmation.6885ab8c.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./switch.b6b8ef92.js"] : void 0, import.meta.url);
      destroyBulkSnapshotComponent.value = module.default;
    };
    async function destroySelectedSnapshots() {
      operationRunning.value = false;
      await loadDestroyBulkSnapshotsComponent();
      showDestroyBulkSnapshotModal.value = true;
      console.log("Selected snapshots to destroy:", selectedForDestroy.value);
    }
    const confirmThisBulkDestroy = () => {
      confirmBulkDestroy.value = true;
    };
    const updateShowDestroyBulkSnapshot = (newVal) => {
      showDestroyBulkSnapshotModal.value = newVal;
    };
    watch(confirmBulkDestroy, async (newVal, oldVal) => {
      const destroyedSnaps = [];
      const failedToDestroySnaps = [];
      if (confirmBulkDestroy.value == true) {
        operationRunning.value = true;
        console.log("now destroying in bulk:", selectedForDestroy.value);
        try {
          let errorMessage;
          for (const snapshot of selectedForDestroy.value) {
            console.log("currently destroying:", snapshot);
            const output = await destroySnapshot(snapshot, false, false);
            if (output == null || output.error) {
              errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
              ;
              failedToDestroySnaps.push(snapshot);
            } else {
              destroyedSnaps.push(snapshot);
            }
          }
          console.log("destroyed:", selectedForDestroy.value);
          await exitBulkDestroyMode();
          confirmBulkDestroy.value = false;
          operationRunning.value = false;
          if (failedToDestroySnaps.length !== 0) {
            pushNotification(new Notification("Destroy Snapshots Failed", `The folllowing snapshots were not destroyed: 
${failedToDestroySnaps.join(", ")}: ${errorMessage}`, "error", 5e3));
          }
          if (destroyedSnaps.length !== 0) {
            pushNotification(new Notification("Snapshot Destroyed", `The folllowing snapshots were destroyed: 
${destroyedSnaps.join(", ")}`, "success", 5e3));
          }
          showDestroyBulkSnapshotModal.value = false;
          await refreshSnaps();
        } catch (error) {
          console.log(error);
          operationRunning.value = false;
          confirmBulkDestroy.value = false;
        }
      }
    });
    async function exitBulkDestroyMode() {
      bulkSnapDestroyMode.set(props.filesystem.name, false);
    }
    const checkboxSelectedClass = (snapshotName) => {
      const isSelected = selectedForDestroy.value.includes(snapshotName);
      return isSelected ? "bg-green-300 dark:bg-green-700" : "";
    };
    const isSelectAllChecked = ref(false);
    function toggleSelectAll() {
      if (isSelectAllChecked.value) {
        selectedForDestroy.value = snapshotsInFilesystem.value.map((snapshot) => snapshot.name);
      } else {
        selectedForDestroy.value = [];
      }
    }
    watch(selectedForDestroy, (newValue) => {
      isSelectAllChecked.value = newValue.length === snapshotsInFilesystem.value.length;
    });
    const checkboxSelectedAllClass = () => {
      return isSelectAllChecked ? "bg-green-300 dark:bg-green-700" : "";
    };
    const showCloneSnapshotModal = ref(false);
    const cloning = ref(false);
    const confirmCloneSnap = inject("confirm-clone-snap");
    const cloneSnapshotComponent = ref();
    const loadCloneSnapshotComponent = async () => {
      const module = await __vitePreload(() => import("./CloneSnapshot.dde33feb.js"), true ? ["./CloneSnapshot.dde33feb.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./switch.b6b8ef92.js"] : void 0, import.meta.url);
      cloneSnapshotComponent.value = module.default;
    };
    async function cloneThisSnapshot(snapshot) {
      selectedSnapshot.value = snapshot;
      console.log("clone snapshot modal triggered");
      await loadCloneSnapshotComponent();
      showCloneSnapshotModal.value = true;
    }
    const updateShowCloneSnapshot = (newVal) => {
      showCloneSnapshotModal.value = newVal;
    };
    watch(confirmCloneSnap, async (newVal, oldVal) => {
      if (confirmCloneSnap.value == true) {
        operationRunning.value = true;
        await refreshSnaps();
        confirmCloneSnap.value = false;
        operationRunning.value = false;
      }
    });
    const showRollbackSnapshotModal = ref(false);
    const confirmRollback = ref(false);
    const rollbackSnapshotComponent = ref();
    const loadRollbackSnapshotComponent = async () => {
      const module = await __vitePreload(() => import("./UniversalConfirmation.6885ab8c.js"), true ? ["./UniversalConfirmation.6885ab8c.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./switch.b6b8ef92.js"] : void 0, import.meta.url);
      rollbackSnapshotComponent.value = module.default;
    };
    async function rollbackThisSnapshot(snapshot) {
      selectedSnapshot.value = snapshot;
      console.log("selected to be rolled back:", selectedSnapshot.value);
      await loadRollbackSnapshotComponent();
      showRollbackSnapshotModal.value = true;
    }
    const confirmThisRollback = () => {
      confirmRollback.value = true;
    };
    const updateShowRollbackSnapshot = (newVal) => {
      showRollbackSnapshotModal.value = newVal;
    };
    watch(confirmRollback, async (newVal, oldVal) => {
      if (confirmRollback.value == true) {
        operationRunning.value = true;
        try {
          const output = await rollbackSnapshot(selectedSnapshot.value, firstOptionToggle.value, secondOptionToggle.value);
          if (output == null || output.error) {
            const errorMessage = (output == null ? void 0 : output.error) || "Unknown error";
            operationRunning.value = false;
            confirmRollback.value = false;
            pushNotification(new Notification("Rollback Snapshot Failed", `${selectedSnapshot.value.name} was not rolled back: ${errorMessage}`, "error", 5e3));
          } else {
            console.log("rolled back:", selectedSnapshot.value);
            await refreshSnaps();
            confirmRollback.value = false;
            operationRunning.value = false;
            pushNotification(new Notification("Snapshot Rolled Back", `Rolled back to snapshot ${selectedSnapshot.value.name} .`, "success", 5e3));
            showRollbackSnapshotModal.value = false;
          }
        } catch (error) {
          console.error(error);
        }
      }
    });
    const showRenameSnapshotModal = ref(false);
    const renaming = ref(false);
    const confirmRename = ref(false);
    const renameSnapshotComponent = ref();
    const loadRenameSnapshotComponent = async () => {
      const module = await __vitePreload(() => import("./RenameSnapshot.6889f8ec.js"), true ? ["./RenameSnapshot.6889f8ec.js","./index.2c5b72b5.js","./index.fc1e9d3c.css","./switch.b6b8ef92.js"] : void 0, import.meta.url);
      renameSnapshotComponent.value = module.default;
    };
    async function renameThisSnapshot(snapshot) {
      selectedSnapshot.value = snapshot;
      console.log("rename snapshot modal triggered");
      await loadRenameSnapshotComponent();
      showRenameSnapshotModal.value = true;
    }
    const updateShowRenameSnapshot = (newVal) => {
      showRenameSnapshotModal.value = newVal;
    };
    watch(confirmRename, async (newVal, oldVal) => {
      if (confirmRename.value == true) {
        operationRunning.value = true;
        await refreshSnaps();
        confirmRename.value = false;
        operationRunning.value = false;
      }
    });
    const showSendSnapshot = ref(false);
    const sendingSnap = ref(false);
    const confirmSendSnap = inject("confirm-send-snap");
    const sendSnapshotComponent = ref();
    const loadSendSnapshotComponent = async () => {
      const module = await __vitePreload(() => import("./SendSnapshot.c64ee980.js"), true ? ["./SendSnapshot.c64ee980.js","./index.2c5b72b5.js","./index.fc1e9d3c.css"] : void 0, import.meta.url);
      sendSnapshotComponent.value = module.default;
    };
    async function sendThisDataset(snapshot) {
      selectedSnapshot.value = snapshot;
      confirmSendSnap.value = false;
      console.log("selected to send:", selectedSnapshot.value);
      await loadSendSnapshotComponent();
      showSendSnapshot.value = true;
    }
    const updateShowSendSnapshot = (newVal) => {
      showSendSnapshot.value = newVal;
    };
    watch(confirmSendSnap, async (newVal, oldVal) => {
      if (confirmSendSnap.value == true) {
        await refreshSnaps();
      }
    });
    provide("cloning", cloning);
    provide("show-clone-modal", showCloneSnapshotModal);
    provide("renaming", renaming);
    provide("confirm-rename", confirmRename);
    provide("show-rename-snap-modal", showRenameSnapshotModal);
    provide("show-send-dataset", showSendSnapshot);
    provide("sending", sendingSnap);
    provide("modal-confirm-running", operationRunning);
    provide("modal-option-one-toggle", firstOptionToggle);
    provide("modal-option-two-toggle", secondOptionToggle);
    provide("modal-option-three-toggle", thirdOptionToggle);
    provide("modal-option-four-toggle", fourthOptionToggle);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock("div", _hoisted_1, [
        props.item == "pool" ? (openBlock(), createElementBlock("div", _hoisted_2, [
          createBaseVNode("table", _hoisted_3, [
            createBaseVNode("thead", _hoisted_4, [
              unref(snapshots).length > 0 && !snapshotsInPoolLoading.value ? (openBlock(), createElementBlock("tr", _hoisted_5, [
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-2 text-center", unref(truncateText)]),
                  title: "Snapshot"
                }, "Snapshot", 2),
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Created On"
                }, "Created On", 2),
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Used"
                }, "Used", 2),
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Referenced"
                }, "Referenced", 2),
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Clones"
                }, "Clones", 2),
                _cache[4] || (_cache[4] = createBaseVNode("th", { class: "relative py-2 sm:pr-6 lg:pr-8 rounded-tr-md col-span-1" }, [
                  createBaseVNode("span", { class: "sr-only" })
                ], -1))
              ])) : createCommentVNode("", true),
              unref(snapshots).length < 1 && !snapshotsInPoolLoading.value ? (openBlock(), createElementBlock("tr", _hoisted_6, _cache[5] || (_cache[5] = [
                createBaseVNode("p", { class: "bg-accent text-default text-center py-2 justify-self-center w-full" }, "No snapshots found.", -1)
              ]))) : createCommentVNode("", true),
              snapshotsInPoolLoading.value ? (openBlock(), createElementBlock("tr", _hoisted_7, [
                createVNode(_sfc_main$1, {
                  width: "w-10",
                  height: "h-10",
                  baseColor: "text-gray-200",
                  fillColor: "fill-slate-500"
                })
              ])) : createCommentVNode("", true)
            ]),
            createBaseVNode("tbody", _hoisted_8, [
              unref(snapshots).length > 0 && !snapshotsInPoolLoading.value ? (openBlock(true), createElementBlock(Fragment, { key: 0 }, renderList(unref(snapshots), (snapshot, snapshotIdx) => {
                return openBlock(), createElementBlock("tr", {
                  key: snapshotIdx,
                  class: "text-default grid grid-cols-7 justify-center items-center"
                }, [
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm font-medium text-default text-left col-span-2", unref(truncateText)]),
                    title: snapshot.name
                  }, toDisplayString(snapshot.name), 11, _hoisted_9),
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.creation.parsed
                  }, toDisplayString(snapshot.properties.creation.parsed), 11, _hoisted_10),
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.used.value
                  }, toDisplayString(snapshot.properties.used.value), 11, _hoisted_11),
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.referenced.value
                  }, toDisplayString(snapshot.properties.referenced.value), 11, _hoisted_12),
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.clones
                  }, toDisplayString(snapshot.properties.clones.length > 0 ? snapshot.properties.clones : "-"), 11, _hoisted_13),
                  createBaseVNode("td", _hoisted_14, [
                    createVNode(unref(ge), {
                      as: "div",
                      class: "relative inline-block text-right"
                    }, {
                      default: withCtx(() => [
                        createBaseVNode("div", null, [
                          createVNode(unref(Se), { class: "flex items-center rounded-full bg-default p-2 text-default hover:text-default focus:outline-none focus:ring-2 focus:ring-slate-500 focus:ring-offset-2 focus:ring-offset-gray-100" }, {
                            default: withCtx(() => [
                              _cache[6] || (_cache[6] = createBaseVNode("span", { class: "sr-only" }, "Open options", -1)),
                              createVNode(unref(render), {
                                class: "w-5",
                                "aria-hidden": "true"
                              })
                            ]),
                            _: 1
                          })
                        ]),
                        createVNode(Transition, {
                          "enter-active-class": "transition ease-out duration-100",
                          "enter-from-class": "transform opacity-0 scale-95",
                          "enter-to-class": "transform opacity-100 scale-100",
                          "leave-active-class": "transition ease-in duration-75",
                          "leave-from-class": "transform opacity-100 scale-100",
                          "leave-to-class": "transform opacity-0 scale-95"
                        }, {
                          default: withCtx(() => [
                            createVNode(unref(Me), {
                              onClick: _cache[0] || (_cache[0] = withModifiers(() => {
                              }, ["stop"])),
                              class: "absolute right-0 z-10 mt-2 w-max origin-top-left rounded-md bg-accent shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none"
                            }, {
                              default: withCtx(() => [
                                createBaseVNode("div", _hoisted_15, [
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => renameThisSnapshot(snapshot),
                                        class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Rename Snapshot", 10, _hoisted_16)
                                    ]),
                                    _: 2
                                  }, 1024),
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => rollbackThisSnapshot(snapshot),
                                        class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Roll Back Snapshot", 10, _hoisted_17)
                                    ]),
                                    _: 2
                                  }, 1024),
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => destroyThisSnapshot(snapshot),
                                        class: normalizeClass([active ? "bg-danger text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Destroy Snapshot", 10, _hoisted_18)
                                    ]),
                                    _: 2
                                  }, 1024)
                                ])
                              ]),
                              _: 2
                            }, 1024)
                          ]),
                          _: 2
                        }, 1024)
                      ]),
                      _: 2
                    }, 1024)
                  ])
                ]);
              }), 128)) : createCommentVNode("", true)
            ])
          ])
        ])) : createCommentVNode("", true),
        props.item == "filesystem" ? (openBlock(), createElementBlock("div", {
          key: 1,
          class: normalizeClass(["inline-block min-w-full max-h-3/4 align-middle border-collapse", { "overflow-y-scroll": snapshotsInFilesystem.value.length > 15 }])
        }, [
          !snapshotsInDatasetLoaded.value && !snapshotNotFound.value ? (openBlock(), createElementBlock("table", _hoisted_19, [
            createBaseVNode("tr", _hoisted_20, [
              createVNode(_sfc_main$1, {
                width: "w-10",
                height: "h-10",
                baseColor: "text-gray-200",
                fillColor: "fill-slate-500"
              })
            ])
          ])) : createCommentVNode("", true),
          snapshotsInFilesystem.value.length > 0 && snapshotsInDatasetLoaded.value ? (openBlock(), createElementBlock("table", _hoisted_21, [
            createBaseVNode("thead", _hoisted_22, [
              createBaseVNode("tr", _hoisted_23, [
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-2 text-center", unref(truncateText)]),
                  title: "Snapshot"
                }, "Snapshot", 2),
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Created On"
                }, "Created On", 2),
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Used"
                }, "Used", 2),
                createBaseVNode("th", {
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Referenced"
                }, "Referenced", 2),
                !unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("th", {
                  key: 0,
                  class: normalizeClass(["py-2 col-span-2 text-center", unref(truncateText)]),
                  title: "Clones"
                }, "Clones", 2)) : createCommentVNode("", true),
                unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("th", {
                  key: 1,
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Clones"
                }, "Clones", 2)) : createCommentVNode("", true),
                unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("th", {
                  key: 2,
                  class: normalizeClass(["py-2 col-span-1 text-center", unref(truncateText)]),
                  title: "Select"
                }, "Select", 2)) : createCommentVNode("", true),
                unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("th", _hoisted_24, [
                  createBaseVNode("label", {
                    class: normalizeClass(["flex flex-row items-center w-full h-full rounded-lg", checkboxSelectedAllClass])
                  }, [
                    withDirectives(createBaseVNode("input", {
                      type: "checkbox",
                      "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => isSelectAllChecked.value = $event),
                      onChange: toggleSelectAll,
                      class: "w-4 h-4 mr-2 text-success border-default rounded focus:ring-green-500 dark:focus:ring-green-600 focus:ring-2"
                    }, null, 544), [
                      [vModelCheckbox, isSelectAllChecked.value]
                    ]),
                    _cache[7] || (_cache[7] = createTextVNode(" Select All "))
                  ])
                ])) : (openBlock(), createElementBlock("th", _hoisted_25, _cache[8] || (_cache[8] = [
                  createBaseVNode("span", { class: "sr-only" }, null, -1)
                ])))
              ])
            ]),
            createBaseVNode("tbody", _hoisted_26, [
              (openBlock(true), createElementBlock(Fragment, null, renderList(snapshotsInFilesystem.value, (snapshot, snapshotIdx) => {
                return openBlock(), createElementBlock("tr", {
                  key: snapshotIdx,
                  class: "text-default grid grid-cols-8 justify-center items-center"
                }, [
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm font-medium text-default text-left col-span-2", unref(truncateText)]),
                    title: snapshot.name
                  }, toDisplayString(snapshot.name), 11, _hoisted_27),
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.creation.parsed
                  }, toDisplayString(snapshot.properties.creation.parsed), 11, _hoisted_28),
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.used.value
                  }, toDisplayString(snapshot.properties.used.value), 11, _hoisted_29),
                  createBaseVNode("td", {
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.referenced.value
                  }, toDisplayString(snapshot.properties.referenced.value), 11, _hoisted_30),
                  !unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("td", {
                    key: 0,
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-2", unref(truncateText)]),
                    title: snapshot.properties.clones
                  }, toDisplayString(snapshot.properties.clones.length > 0 ? snapshot.properties.clones : "-"), 11, _hoisted_31)) : createCommentVNode("", true),
                  unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("td", {
                    key: 1,
                    class: normalizeClass(["py-1 px-3 text-sm text-default text-center col-span-1", unref(truncateText)]),
                    title: snapshot.properties.clones
                  }, toDisplayString(snapshot.properties.clones.length > 0 ? snapshot.properties.clones : "-"), 11, _hoisted_32)) : createCommentVNode("", true),
                  unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("td", _hoisted_33, [
                    createBaseVNode("label", {
                      class: normalizeClass(["flex justify-center items-center w-full h-full py-2 rounded-lg border border-default bg-well", checkboxSelectedClass(snapshot.name)])
                    }, [
                      withDirectives(createBaseVNode("input", {
                        "onUpdate:modelValue": _cache[2] || (_cache[2] = ($event) => selectedForDestroy.value = $event),
                        type: "checkbox",
                        value: snapshot.name,
                        class: "w-4 h-4 text-success border-default rounded focus:ring-green-500 dark:focus:ring-green-600 focus:ring-2"
                      }, null, 8, _hoisted_34), [
                        [vModelCheckbox, selectedForDestroy.value]
                      ])
                    ], 2)
                  ])) : createCommentVNode("", true),
                  createBaseVNode("td", _hoisted_35, [
                    createVNode(unref(ge), {
                      as: "div",
                      class: "relative inline-block text-right"
                    }, {
                      default: withCtx(() => [
                        createBaseVNode("div", null, [
                          createVNode(unref(Se), { class: "flex items-center rounded-full bg-accent p-2 text-muted hover:text-gray-600 focus:outline-none focus:ring-2 focus:ring-slate-500 focus:ring-offset-2 focus:ring-offset-gray-100" }, {
                            default: withCtx(() => [
                              _cache[9] || (_cache[9] = createBaseVNode("span", { class: "sr-only" }, "Open options", -1)),
                              createVNode(unref(render), {
                                class: "w-5",
                                "aria-hidden": "true"
                              })
                            ]),
                            _: 1
                          })
                        ]),
                        createVNode(Transition, {
                          "enter-active-class": "transition ease-out duration-100",
                          "enter-from-class": "transform opacity-0 scale-95",
                          "enter-to-class": "transform opacity-100 scale-100",
                          "leave-active-class": "transition ease-in duration-75",
                          "leave-from-class": "transform opacity-100 scale-100",
                          "leave-to-class": "transform opacity-0 scale-95"
                        }, {
                          default: withCtx(() => [
                            createVNode(unref(Me), { class: "absolute right-0 z-10 mt-2 w-max origin-top-left rounded-md bg-accent shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none" }, {
                              default: withCtx(() => [
                                createBaseVNode("div", _hoisted_36, [
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => cloneThisSnapshot(snapshot),
                                        class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Clone Snapshot", 10, _hoisted_37)
                                    ]),
                                    _: 2
                                  }, 1024),
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => renameThisSnapshot(snapshot),
                                        class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Rename Snapshot", 10, _hoisted_38)
                                    ]),
                                    _: 2
                                  }, 1024),
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => rollbackThisSnapshot(snapshot),
                                        class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Roll Back Snapshot", 10, _hoisted_39)
                                    ]),
                                    _: 2
                                  }, 1024),
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => sendThisDataset(snapshot),
                                        class: normalizeClass([active ? "bg-default text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Send Snapshot", 10, _hoisted_40)
                                    ]),
                                    _: 2
                                  }, 1024),
                                  createVNode(unref(be), { as: "div" }, {
                                    default: withCtx(({ active }) => [
                                      createBaseVNode("a", {
                                        href: "#",
                                        onClick: ($event) => destroyThisSnapshot(snapshot),
                                        class: normalizeClass([active ? "bg-danger text-default" : "text-muted", "block px-4 py-2 text-sm"])
                                      }, "Destroy Snapshot", 10, _hoisted_41)
                                    ]),
                                    _: 2
                                  }, 1024)
                                ])
                              ]),
                              _: 2
                            }, 1024)
                          ]),
                          _: 2
                        }, 1024)
                      ]),
                      _: 2
                    }, 1024)
                  ])
                ]);
              }), 128))
            ])
          ])) : createCommentVNode("", true),
          unref(bulkSnapDestroyMode).get(props.filesystem.name) ? (openBlock(), createElementBlock("button", {
            key: 2,
            onClick: _cache[3] || (_cache[3] = ($event) => destroySelectedSnapshots()),
            name: "destroy-multiple-snaps-btn",
            class: "mt-1 btn btn-danger h-fit w-full"
          }, "Destroy Selected Snapshots")) : createCommentVNode("", true),
          snapshotsInFilesystem.value.length === 0 && snapshotNotFound.value ? (openBlock(), createElementBlock("div", _hoisted_42, _cache[10] || (_cache[10] = [
            createBaseVNode("p", null, "No snapshots found.", -1)
          ]))) : createCommentVNode("", true)
        ], 2)) : createCommentVNode("", true),
        showDestroySnapshotModal.value ? (openBlock(), createElementBlock("div", _hoisted_43, [
          (openBlock(), createBlock(resolveDynamicComponent(destroySnapshotComponent.value), {
            showFlag: showDestroySnapshotModal.value,
            onClose: updateShowDestroySnapshot,
            idKey: "confirm-destroy-snapshot",
            item: "snapshot",
            operation: "destroy",
            snapshot: selectedSnapshot.value,
            confirmOperation: confirmThisDestroy,
            firstOption: "Destroy child snapshots with same name",
            secondOption: "Force Destroy ALL child datasets",
            hasChildren: hasChildren.value
          }, null, 40, ["showFlag", "snapshot", "hasChildren"]))
        ])) : createCommentVNode("", true),
        showCloneSnapshotModal.value ? (openBlock(), createElementBlock("div", _hoisted_44, [
          (openBlock(), createBlock(resolveDynamicComponent(cloneSnapshotComponent.value), {
            onClose: updateShowCloneSnapshot,
            idKey: "clone-snapshot-modal",
            snapshot: selectedSnapshot.value
          }, null, 40, ["snapshot"]))
        ])) : createCommentVNode("", true),
        showRenameSnapshotModal.value ? (openBlock(), createElementBlock("div", _hoisted_45, [
          (openBlock(), createBlock(resolveDynamicComponent(renameSnapshotComponent.value), {
            onClose: updateShowRenameSnapshot,
            idKey: "rename-snapshot-modal",
            snapshot: selectedSnapshot.value
          }, null, 40, ["snapshot"]))
        ])) : createCommentVNode("", true),
        showRollbackSnapshotModal.value ? (openBlock(), createElementBlock("div", _hoisted_46, [
          (openBlock(), createBlock(resolveDynamicComponent(rollbackSnapshotComponent.value), {
            showFlag: showRollbackSnapshotModal.value,
            onClose: updateShowRollbackSnapshot,
            idKey: "confirm-rollback-snapshot",
            item: "snapshot",
            operation: "rollback",
            snapshot: selectedSnapshot.value,
            confirmOperation: confirmThisRollback,
            firstOption: "Destroy all newer snapshots of file system",
            secondOption: "Force Destroy ALL newer datasets",
            hasChildren: hasChildren.value
          }, null, 40, ["showFlag", "snapshot", "hasChildren"]))
        ])) : createCommentVNode("", true),
        showSendSnapshot.value ? (openBlock(), createElementBlock("div", _hoisted_47, [
          (openBlock(), createBlock(resolveDynamicComponent(sendSnapshotComponent.value), {
            onClose: updateShowSendSnapshot,
            idKey: "'show-send-snapshot-modal'",
            snapshot: selectedSnapshot.value,
            name: selectedSnapshot.value.name
          }, null, 40, ["snapshot", "name"]))
        ])) : createCommentVNode("", true),
        showDestroyBulkSnapshotModal.value ? (openBlock(), createElementBlock("div", _hoisted_48, [
          (openBlock(), createBlock(resolveDynamicComponent(destroyBulkSnapshotComponent.value), {
            showFlag: showDestroyBulkSnapshotModal.value,
            onClose: updateShowDestroyBulkSnapshot,
            idKey: "confirm-destroy-bulk-snapshots",
            item: "snapshots",
            operation: "destroy",
            snapshots: selectedForDestroy.value,
            confirmOperation: confirmThisBulkDestroy,
            hasChildren: false
          }, null, 40, ["showFlag", "snapshots"]))
        ])) : createCommentVNode("", true)
      ]);
    };
  }
});
export {
  _sfc_main as _
};
